Include ButtonLib.Inc
Include ExportFunctions.Asm
	
.Code
	RegisterCusButton Proc hInst :DWord
		Local CustomButton : WNDCLASSEX		

		Use CustomButton.hInstance		 , hInst
		Mov CustomButton.cbSize      	 , SizeOf WNDCLASSEX
		Mov CustomButton.style         , CS_BYTEALIGNCLIENT Or CS_BYTEALIGNWINDOW Or\
																		 CS_GLOBALCLASS Or CS_VREDRAW Or CS_HREDRAW
		Mov CustomButton.lpfnWndProc 	 , OffSet CusButtonProc
		Mov CustomButton.cbWndExtra  	 , BTN_PROPERTIES
		Mov CustomButton.cbClsExtra  	 , Null
		Mov CustomButton.hIcon 			 	 , Null
		Mov CustomButton.hCursor		 	 , Null
		Mov CustomButton.hbrBackground , Null
		Mov CustomButton.lpszMenuName  , Null
		Mov CustomButton.hIconSm       , Null
		Mov CustomButton.lpszClassName , StringO('CusButton')

		Invoke RegisterClassExA , Addr CustomButton
		Ret
	RegisterCusButton EndP
	
	CusButtonProc Proc hWin :DWord, uMsg :DWord, wParam :DWord, lParam :DWord
	  Local hParent     :DWord
	  Local hDC         :DWord
	  Local hFont       :DWord
	  Local hOld        :DWord
	  Local Buffer[128] :Byte
	  Local CurColor		:DWord
	  Local IHeight			:DWord
	  Local IRight			:DWord
	  Local Ps          :PAINTSTRUCT
	
	  .If uMsg == WM_INITCUSBUTTON
	    Push Edi
	    Mov  Edi , wParam	
			Invoke SetWindowLong, hWin, BTN_BUPCOLOR,   (CusButtonStruct Ptr [Edi]).bUpColor
			Invoke SetWindowLong, hWin, BTN_BDOWNCOLOR, (CusButtonStruct Ptr [Edi]).bDownColor
	    Invoke SetWindowLong, hWin, BTN_FUPCOLOR,   (CusButtonStruct Ptr [Edi]).fUpColor
	    Invoke SetWindowLong, hWin, BTN_FDOWNCOLOR, (CusButtonStruct Ptr [Edi]).fDownColor
	    Invoke SetWindowLong, hWin, BTN_HFONT, 			(CusButtonStruct Ptr [Edi]).hWndFont
	    Invoke SetWindowLong, hWin, BTN_TEXTALIGN,  (CusButtonStruct Ptr [Edi]).CaptionAlign
			Invoke SetWindowLong, hWin, BTN_IMGLST, 		(CusButtonStruct Ptr [Edi]).CBImgLst
			Invoke SetWindowLong, hWin, BTN_IMGINFO,		(CusButtonStruct Ptr [Edi]).CBImgInfo
	    Invoke SetWindowLong, hWin, BTN_CLICKSTATE, BTS_UNCLICKED
	    Mov Eax , (CusButtonStruct Ptr [Edi]).lpCaption
	    .If Eax
				Invoke SetCBCaption,  hWin, (CusButtonStruct Ptr [Edi]).lpCaption
			.EndIf
			Pop Edi	
		
		.ElseIf uMsg == WM_RAINIT ;Default properties for RadAsm Dialog editor
	    Invoke SetWindowLong, hWin, BTN_FUPCOLOR,   0FFh
	    Invoke SetWindowLong, hWin, BTN_FDOWNCOLOR, 0FFh
	    Invoke SetWindowLong, hWin, BTN_TEXTALIGN,  BTA_TCENTER
	    Invoke SetWindowLong, hWin, BTN_CLICKSTATE, BTS_UNCLICKED

			Invoke RedrawWindow, hWin, 0, 0, RDW_INTERNALPAINT
			Invoke SendMessageA, hWin, WM_PAINT, 0, 0			

	  .ElseIf uMsg == WM_LBUTTONDOWN
	    Invoke SetWindowLong	, hWin, BTN_CLICKSTATE, BTS_CLICKED
	    Invoke SetCapture			, hWin
;			Invoke GetClientRect	, hWin, Addr Ps.rcPaint
;	    Invoke InvalidateRect	, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True

	  .ElseIf uMsg == WM_LBUTTONUP
	    Invoke SetWindowLong,  hWin, BTN_CLICKSTATE, BTS_UNCLICKED
	    Invoke ReleaseCapture
;	    Invoke GetWindowLong,  hWin, BTN_BUPCOLOR
;	    Invoke GetClientRect,  hWin, Addr Ps.rcPaint
;	    Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
	    Invoke GetClientRect,  hWin, Addr Ps.rcPaint

			;Get mouse position
			MovSx Eax , Word Ptr lParam
			Mov 	Ecx , lParam
			Shr 	Ecx , 16
			;Raise click event if cursor is over the button
			.If (Eax > Ps.rcPaint.left) && (Eax < Ps.rcPaint.right) &&\
				  (Ecx > Ps.rcPaint.top) && (Ecx < Ps.rcPaint.bottom)
	      Invoke GetParent, hWin
	      Mov hParent, Eax
				Invoke GetDlgCtrlID, hWin
				Invoke SendMessage, hParent, WM_COMMAND, Eax, hWin
			.EndIf

	  .ElseIf uMsg == WM_SETTEXT
;      Invoke GetClientRect,  hWin, Addr Ps.rcPaint
;	    Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
	
	  .ElseIf uMsg == WM_SETFONT
	    Invoke SetWindowLong,  hWin, BTN_HFONT, wParam
;      Invoke GetClientRect,  hWin, Addr Ps.rcPaint
;	    Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
	
	  .ElseIf uMsg == WM_COMMAND
	    .If wParam == BTM_SETBKUCOLOR
				Invoke SetWindowLong, hWin, BTN_BUPCOLOR, lParam

	    .ElseIf wParam == BTM_SETBKPCOLOR
				Invoke SetWindowLong, hWin, BTN_BDOWNCOLOR, lParam
	
	    .ElseIf wParam == BTM_SETFUCOLOR
	      Invoke SetWindowLong, hWin, BTN_FUPCOLOR, lParam
	
	    .ElseIf wParam == BTM_SETFPCOLOR
	      Invoke SetWindowLong, hWin, BTN_FDOWNCOLOR, lParam
	
	    .ElseIf wParam == BTM_SETTEXTALIGN
	    	Invoke SetWindowLong, hWin, BTN_TEXTALIGN, lParam
	    
	    .ElseIf wParam == BTM_SETIMGALIGN
				Invoke GetWindowLong, hWin, BTN_IMGINFO
				Use (CBImgInfoStruct Ptr [Eax]).IAlign , lParam
			
			.ElseIf wParam == BTM_SETFONT
				Invoke SetWindowLong, hWin, BTN_HFONT, lParam
	    	
	    .EndIf
;      Invoke GetClientRect,  hWin, Addr Ps.rcPaint
;	    Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
	
		.ElseIf uMsg == WM_MOUSEMOVE
			Invoke GetWindowLong, hWin, BTN_CLICKSTATE
			.If Eax==BTS_UNCLICKED
				Invoke SetWindowLong,  hWin, BTN_CLICKSTATE, BTS_MOUSEOVER
;	      Invoke GetClientRect,  hWin, Addr Ps.rcPaint
;		    Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
				Invoke InvalidateRect, hWin, Null, True
		  .EndIf

		.ElseIf uMsg == WM_MOUSEOUT	;Custom message to know when I lost the focus
			Invoke SetWindowLong,  hWin, BTN_CLICKSTATE, BTS_UNCLICKED
;      Invoke GetClientRect,  hWin, Addr Ps.rcPaint
;	    Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
						
	  .ElseIf uMsg == WM_PAINT
	    Invoke BeginPaint, hWin, Addr Ps
	    Mov hDC, Eax
			Invoke GetClientRect, hWin, Addr Ps.rcPaint		
	    Invoke GetWindowText, hWin, Addr Buffer, SizeOf Buffer
	    Invoke GetWindowLong, hWin, BTN_HFONT
	    .If Eax
	      Mov hFont, Eax
	      Invoke SelectObject, hDC, hFont
	      Mov hOld, Eax
	    .EndIf
	
	    Invoke GetWindowLong, hWin, BTN_CLICKSTATE
	    ;Draw unclicked button
	    .If Eax == BTS_UNCLICKED || Eax == BTS_MOUSEOVER
	      Invoke GetWindowLong, hWin, BTN_BUPCOLOR
	      Mov CurColor , Eax
	      Invoke SetBkColor, hDC, Eax
	      .If hWndBgColor
	      	Invoke DeleteObject, hWndBgColor
	      .EndIf
				Invoke CreateSolidBrush, CurColor
				Mov hWndBgColor , Eax
	      Invoke FillRect, hDC, Addr Ps.rcPaint, hWndBgColor
        Invoke DrawEdge, hDC, Addr Ps.rcPaint, EDGE_RAISED, BF_RECT
	      Invoke GetWindowLong, hWin, BTN_FUPCOLOR
			;Draw clicked button
	    .ElseIf Eax == BTS_CLICKED || Eax == BTS_MOUSEOVER
	      Invoke GetWindowLong, hWin, BTN_BDOWNCOLOR
	      Mov CurColor, Eax
	      Invoke SetBkColor, hDC, Eax
	      .If hWndBgColor 
	      	Invoke DeleteObject, hWndBgColor
	      .EndIf
				Invoke CreateSolidBrush, CurColor
	      Mov hWndBgColor, Eax
	      Invoke FillRect, hDC, Addr Ps.rcPaint, hWndBgColor
	      Invoke DrawEdge, hDC, Addr Ps.rcPaint, EDGE_SUNKEN, BF_RECT
	      Invoke GetWindowLong, hWin, BTN_FDOWNCOLOR
	    .EndIf
	    Invoke SetTextColor, hDC, Eax   

			Invoke GetWindowLong, hWin, BTN_IMGLST
			.If Eax
				Push Edi
				Mov  Edi , Eax
				Mov  Eax , Ps.rcPaint.bottom
				Sub  Eax , Ps.rcPaint.top
				Sub  Eax , (ImgStruct Ptr [Edi]).iHeight
				Xor  Edx , Edx
				Mov  Ecx , 2
				IDiv Ecx
				Mov IHeight , Eax
				Invoke GetCusButtonImage, hWin
				Mov Ebx , Eax

				Invoke GetWindowLong, hWin, BTN_IMGINFO
				Mov Eax , (CBImgInfoStruct Ptr [Eax]).IAlign
				.If Eax==BTA_ILEFT 				
					Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
					Inc Eax
				.ElseIf Eax==BTA_IRIGHT
					Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
					Mov Edx , Eax
					Mov Eax , Ps.rcPaint.right
					Sub Eax , (ImgStruct Ptr [Edi]).iWidth
					Sub Eax , Edx
					Dec Eax
					Mov IRight , Eax
				.ElseIf Eax==BTA_ICENTER
					Mov  Eax , Ps.rcPaint.right
					Sub  Eax , Ps.rcPaint.left
					Sub  Eax , (ImgStruct Ptr [Edi]).iWidth
					Mov  Ecx , 2
					Xor  Edx , Edx
					IDiv Ecx
				.EndIf
				Invoke ImageList_Draw, (ImgStruct Ptr [Edi]).hWndImgLst, Ebx, hDC, Eax, IHeight, ILD_NORMAL

				Invoke GetWindowLong, hWin, BTN_TEXTALIGN
				Mov Ebx , Eax
				Invoke GetWindowLong, hWin, BTN_IMGINFO
				Mov Eax , (CBImgInfoStruct Ptr [Eax]).IAlign
				.If Ebx==BTA_TLEFT && Eax==BTA_ILEFT
					Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
					Add Eax , Ps.rcPaint.left
					Add Eax , (ImgStruct Ptr [Edi]).iWidth
					Mov Ps.rcPaint.left , Eax
				.ElseIf Ebx==BTA_TRIGHT && Eax==BTA_IRIGHT
					Use Ps.rcPaint.right , IRight
				.Else
			    Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
			    Add Ps.rcPaint.left  , Eax
			    Inc Ps.rcPaint.left
			    Sub Ps.rcPaint.right , Eax
			    Dec Ps.rcPaint.right
				.EndIf
				Pop Edi
			.Else
		    Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
		    Add Ps.rcPaint.left  , Eax
		    Inc Ps.rcPaint.left
		    Sub Ps.rcPaint.right , Eax
		    Dec Ps.rcPaint.right
	    .EndIf
 	    
			Invoke GetWindowLong, hWin, BTN_TEXTALIGN
      Invoke SetCusButtonTextAlign, Eax
	    Invoke DrawText, hDC, Addr Buffer, -1, Addr Ps.rcPaint, dtStyle
	
			Invoke GetWindowLong, hWin, BTN_HFONT
			.If Eax
			  Invoke SelectObject, hDC, hOld
			.EndIf
	    Invoke EndPaint, hWin, Addr Ps

		.ElseIf uMsg==WM_DESTROY
			.If hWndBgColor
		    Invoke DeleteObject, hWndBgColor
		  .EndIf
	  .EndIf
	  Invoke DefWindowProc,hWin,uMsg,wParam,lParam
	  Ret
	CusButtonProc EndP

