Include StatusLib.Inc
Include SBExportFunction.Asm

.Code
	RegisterCusSBar Proc hInst :DWord
		Local CusSBar : WNDCLASSEX

		Use CusSBar.hInstance		 	, hInst
		Mov CusSBar.cbSize      	, SizeOf WNDCLASSEX
		Mov CusSBar.style         , CS_VREDRAW Or CS_HREDRAW Or CS_GLOBALCLASS
		Mov CusSBar.lpfnWndProc 	, OffSet CusStatusProc
		Mov CusSBar.cbWndExtra		, SB_PROPERTIES
		Invoke LoadCursor, Null, IDC_ARROW
		Mov CusSBar.hCursor		 	 	, Eax
		Mov CusSBar.cbClsExtra  	, Null
		Mov CusSBar.hIcon 			 	, Null
		Mov CusSBar.hbrBackground , Null
		Mov CusSBar.lpszMenuName  , Null
		Mov CusSBar.hIconSm       , Null
		Mov CusSBar.lpszClassName , StringO('CusSBar')

		Invoke RegisterClassEx, Addr CusSBar
		Ret
	RegisterCusSBar EndP

;/----------------------------------------\
;| Save parts properties								  |
;| -------------------------------------- |
;| Input:																	|
;| Status handle													|
;| Pointer to SBParts struct							|
;| -------------------------------------- |
;| Output:																|
;| See description												|
;| -------------------------------------- |
;| Author  : KahnAbyss										|
;| Date	   : 12/01/2003										|
;| Updated : 12/01/2003										|
;| Version : 1.0													|
;\----------------------------------------/
	FillCusSBarParts Proc Uses Esi Edi hWin :DWord, Parts :DWord
		Local NbParts :DWord
		
		Invoke GetWindowLong, hWin, SB_NBRPARTS
		Mov NbParts , Eax
		Invoke GetWindowLong, hWin, SB_PARTS
		Mov Esi , Eax
		Mov Edi , Parts

		Xor Ecx , Ecx
		.While Ecx < NbParts
			Mov  Edx , Ecx
			IMul Edx , SizeOf SBParts
			Use (SBParts Ptr [Esi])[Edx].SBLeft 	 , (SBParts Ptr [Edi])[Edx].SBLeft
			Use (SBParts Ptr [Esi])[Edx].SBCaption , (SBParts Ptr [Edi])[Edx].SBCaption
			Use (SBParts Ptr [Esi])[Edx].SBBGColor , (SBParts Ptr [Edi])[Edx].SBBGColor
			Use (SBParts Ptr [Esi])[Edx].SBCColor  , (SBParts Ptr [Edi])[Edx].SBCColor
			Use (SBParts Ptr [Esi])[Edx].hWndFont  , (SBParts Ptr [Edi])[Edx].hWndFont
			Use (SBParts Ptr [Esi])[Edx].CAlign		 , (SBParts Ptr [Edi])[Edx].CAlign
			Use (SBParts Ptr [Esi])[Edx].ImageID	 , (SBParts Ptr [Edi])[Edx].ImageID
			Use (SBParts Ptr [Esi])[Edx].IAlign		 , (SBParts Ptr [Edi])[Edx].IAlign
			
			Inc Ecx
		.EndW
		Ret
	FillCusSBarParts EndP

;/----------------------------------------\
;| Free memory that I used for parts		  |
;| -------------------------------------- |
;| Input:																	|
;| Status handle													|
;| -------------------------------------- |
;| Output:																|
;| See description												|
;| -------------------------------------- |
;| Author  : KahnAbyss										|
;| Date	   : 12/01/2003										|
;| Updated : 12/01/2003										|
;| Version : 1.0													|
;\----------------------------------------/
	FreeCusSBarParts Proc hWin :DWord
		Invoke GetWindowLong, hWin, SB_NBRPARTS
		.If Eax
			IMul Eax , SizeOf SBParts
			Push Eax
			Invoke GetWindowLong, hWin, SB_PARTS
			.If Eax
				Mov  Ebx , Eax
				Pop  Eax
				Invoke VirtualFree, Ebx, Eax, MEM_DECOMMIT
			.EndIf
		.EndIf
		Ret
	FreeCusSBarParts EndP

	SetCusSBarTextAlign Proc pAlign :DWord
		Mov dtStyle , DT_VCENTER Or DT_SINGLELINE
    .If pAlign == BTA_LEFT
      Or dtStyle , DT_LEFT
    .ElseIf pAlign == BTA_CENTER
      Or dtStyle , DT_CENTER
    .ElseIf pAlign == BTA_RIGHT
      Or dtStyle , DT_RIGHT
    .EndIf		
		Ret
	SetCusSBarTextAlign EndP

	PlaceSBar Proc hWin :DWord
		Local pRect 	 : RECT
		Local ctlRect	 : RECT
		
		Invoke GetParent, hWin
		Mov Ebx , Eax
		Invoke GetClientRect, Ebx, Addr pRect
		Invoke GetWindowRect, hWin, Addr ctlRect

		Mov Edx , ctlRect.bottom
		Sub Edx , ctlRect.top
		.If Edx
			Mov Ebx , pRect.bottom
			Sub Ebx , pRect.top
			Sub Ebx , Edx
			Mov Ecx , pRect.right
			Sub Ecx , pRect.left

			Push Ecx
			Invoke MoveWindow, hWin, 0, Ebx, Ecx, Edx, True
			Invoke GetWindowLong, hWin, SB_NBRPARTS
			.If Eax
				Mov  Edx , Eax
				Dec  Edx
				IMul Edx , SizeOf SBParts
				Push Edx
				Invoke GetWindowLong, hWin, SB_PARTS
				Pop Edx
				Pop Ecx
				Mov (SBParts Ptr [Eax])[Edx].SBLeft , Ecx
			.EndIf
		.EndIf
		Ret
	PlaceSBar EndP

;	DetectCusSBar Proc hWin :DWord
;		Local hParent :DWord
;		Local hSBar	  :DWord
;		Local NbrSBar :DWord
;		
;		Invoke GetParent, hWin
;		Mov hParent , Eax
;		
;		Mov NbrSBar , 0
;		Mov hSBar		, 0
;		.While Eax
;			Invoke FindWindowEx, hParent, hSBar, String('CusSBar'), Null
;			.If Eax
;				Inc NbrSBar
;				Mov hSBar , Eax
;			.EndIf	
;		.EndW
;		Return NbrSBar
;	DetectCusSBar EndP

	CusStatusProc Proc hWin :DWord, uMsg :DWord, wParam :DWord, lParam :DWord
		Local Ps 					:PAINTSTRUCT
		Local hDc 				:DWord
		Local hFont				:DWord
		Local hOld				:DWord
		Local Buffer[128] :Byte
		Local PrevLeft		:DWord
		Local NbParts			:DWord
		Local CurPart			:DWord
		Local IHeight			:DWord
		Local IRight			:DWord
				
  	.If uMsg == WM_RAINIT ;Default properties for RadAsm Dialog editor
;			Invoke DetectCusSBar, hWin
;			.If Eax > 1
;
;			.Else
				Invoke RedrawWindow, hWin, 0, 0, RDW_INTERNALPAINT
				Invoke SendMessageA, hWin, WM_PAINT, 0, 0
;			.EndIf
  	
  	.ElseIf uMsg==WM_PAINT
			Invoke PlaceSBar, hWin
	   	Invoke BeginPaint, hWin, Addr Ps
	   	Mov hDc , Eax
			Invoke GetClientRect, hWin, Addr Ps.rcPaint	   	
	   	Invoke GetWindowLong, hWin, SB_NBRPARTS
	   	Mov NbParts  , Eax
	   	Mov CurPart  , 0
	   	Mov PrevLeft , 0
	   	Xor Ecx , Ecx
	   	.While Ecx < NbParts   	
				Invoke DrawEdge, hDc, Addr Ps.rcPaint, EDGE_SUNKEN, BF_RECT
		   	Invoke SetBkMode, hDc, TRANSPARENT
		   	.If hWndSBBkColor
		   		Invoke DeleteObject, hWndSBBkColor
		   	.EndIf
	
				Invoke GetWindowLong, hWin, SB_NBRPARTS
				.If Eax
					Push Esi
					Invoke GetWindowLong, hWin, SB_PARTS
					Mov  Esi , Eax
					Mov  Edx , CurPart
					IMul Edx , SizeOf SBParts
					Add  Esi , Edx
					
					Mov Eax , (SBParts Ptr [Esi]).hWndFont
			    .If Eax
			      Mov hFont, Eax
			      Invoke SelectObject, hDc, hFont
			      Mov hOld, Eax
			    .EndIf
		    				
					Mov Eax , (SBParts Ptr [Esi]).SBBGColor
					Invoke CreateSolidBrush, Eax
			   	Mov hWndSBBkColor , Eax
			   	
			   	Mov Eax , (SBParts Ptr [Esi]).SBCColor
			   	Invoke SetTextColor, hDc, Eax
	
					Use Ps.rcPaint.right , (SBParts Ptr [Esi]).SBLeft
			   	Use Ps.rcPaint.left  , PrevLeft
			   	Use PrevLeft 				 , (SBParts Ptr [Esi]).SBLeft

			   	Invoke FillRect, hDc, Addr Ps.rcPaint, hWndSBBkColor
					Invoke DrawEdge, hDc, Addr Ps.rcPaint, EDGE_SUNKEN, BF_RECT

					Invoke SetCusSBarTextAlign, (SBParts Ptr [Esi]).CAlign
					Use rcCap.left   , Ps.rcPaint.left
					Use rcCap.right	 , Ps.rcPaint.right
					Use rcCap.top		 , Ps.rcPaint.top
					Use rcCap.bottom , Ps.rcPaint.bottom
					Invoke GetWindowLong, hWin, SB_IMGLIST
					.If Eax
						Mov Ebx , (SBParts Ptr [Esi]).ImageID
						.If !Sign?
							Push Edi
							Mov  Edi , Eax
							Mov  Eax , rcCap.bottom
							Sub  Eax , rcCap.top
							Sub  Eax , (ImgStruct Ptr [Edi]).iHeight
							Xor  Edx , Edx
							Mov  Ecx , 2
							IDiv Ecx
							Mov IHeight , Eax
			
							Mov Eax , (SBParts Ptr [Esi]).IAlign
							.If Eax==BTA_ILEFT 				
								Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
								Inc Eax
								Add Eax , rcCap.left

							.ElseIf Eax==BTA_IRIGHT
								Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
								Mov Edx , Eax
								Mov Eax , rcCap.right
								Sub Eax , (ImgStruct Ptr [Edi]).iWidth
								Sub Eax , Edx
								Dec Eax
								Mov IRight , Eax
								
							.ElseIf Eax==BTA_ICENTER
								Mov  Eax , rcCap.right
								Sub  Eax , rcCap.left
								Sub  Eax , (ImgStruct Ptr [Edi]).iWidth
								Mov  Ecx , 2
								Xor  Edx , Edx
								IDiv Ecx
								Add  Eax , rcCap.left
							.EndIf
							Invoke ImageList_Draw, (ImgStruct Ptr [Edi]).hWndImgLst, Ebx, hDc, Eax, IHeight, ILD_NORMAL
			
							Mov Ebx , (SBParts Ptr [Esi]).CAlign
							Mov Eax , (SBParts Ptr [Esi]).IAlign
							.If Ebx==BTA_TLEFT && Eax==BTA_ILEFT
								Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
								Add Eax , Ps.rcPaint.left
								Add Eax , (ImgStruct Ptr [Edi]).iWidth
								Add Eax , 2
								Mov rcCap.left , Eax
							.ElseIf Ebx==BTA_TRIGHT && Eax==BTA_IRIGHT
								Mov Eax , IRight
								Sub Eax , 2
								Mov rcCap.right , Eax
							.Else
						    Invoke GetSystemMetrics, SM_CXBORDER Or SM_CXEDGE Or SM_CXFRAME
						    Add rcCap.left  , Eax
						    Inc rcCap.left
						    Sub rcCap.right , Eax
						    Dec rcCap.right
							.EndIf
							Pop Edi
						.Else
							Add rcCap.left  , 4
							Sub rcCap.right , 10
						.EndIf
					.Else
						Add rcCap.left  , 4
						Sub rcCap.right , 10
					.EndIf
					
					.If (CurPart==0)
						Invoke lstrlen, (SBParts Ptr [Esi]).SBCaption
						.If Eax
							Invoke DrawText, hDc, (SBParts Ptr [Esi]).SBCaption, -1, Addr rcCap, dtStyle
					  .Else
							Invoke GetWindowText, hWin, Addr Buffer, SizeOf Buffer
					   	Invoke DrawText, hDc, Addr Buffer, -1, Addr rcCap, dtStyle
						.EndIf
					.Else
						Invoke DrawText, hDc, (SBParts Ptr [Esi]).SBCaption, -1, Addr rcCap, dtStyle
					.EndIf
				
					Mov Eax , (SBParts Ptr [Esi]).hWndFont
					.If Eax
					  Invoke SelectObject, hDc, hOld
					.EndIf
					Inc CurPart
					Mov Ecx , CurPart
 					Pop Esi
				.EndIf
			.EndW

			.If NbParts==0
				Invoke SetBkMode, hDc, TRANSPARENT
				Invoke SetTextColor, hDc, 0FFh
		   	.If hWndSBBkColor
		   		Invoke DeleteObject, hWndSBBkColor
		   	.EndIf
		   	Invoke CreateSolidBrush, 0
		   	Mov hWndSBBkColor , Eax
			
				Invoke SetCusSBarTextAlign, BTA_LEFT
				Invoke FillRect, hDc, Addr Ps.rcPaint, hWndSBBkColor
				Invoke DrawEdge, hDc, Addr Ps.rcPaint, EDGE_SUNKEN, BF_RECT
				Invoke GetWindowText, hWin, Addr Buffer, SizeOf Buffer
				Add Ps.rcPaint.left  , 4
				Invoke DrawText, hDc, Addr Buffer, -1, Addr Ps.rcPaint, dtStyle
			.EndIf
	   	Invoke EndPaint, hWin, Addr Ps

		.ElseIf uMsg==SB_SETPARTS
			Invoke FreeCusSBarParts, hWin
			Mov  Eax , wParam
			IMul Eax , SizeOf SBParts
			Invoke VirtualAlloc, Null, Eax, MEM_COMMIT, PAGE_READWRITE
			Invoke SetWindowLong, hWin, SB_PARTS, Eax		
			Invoke SetWindowLong, hWin, SB_NBRPARTS, wParam
			Invoke FillCusSBarParts, hWin, lParam
;			Invoke GetClientRect, hWin, Addr Ps.rcPaint
;			Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
			
		.ElseIf uMsg==SB_SETTEXT
;//@@ToDo Add uType to wParam
			Invoke GetWindowLong, hWin, SB_PARTS
			Push Esi
			Mov  Esi , Eax
			Mov  Eax , wParam
			IMul Eax , SizeOf SBParts
			Add  Esi , Eax
			Use (SBParts Ptr [Esi]).SBCaption , lParam
			Pop Esi
;			Invoke GetClientRect, hWin, Addr Ps.rcPaint
;			Invoke InvalidateRect, hWin, Addr Ps.rcPaint, True
			Invoke InvalidateRect, hWin, Null, True
						
	  .ElseIf uMsg==WM_DESTROY
	   	.If hWndSBBkColor
	   		Invoke DeleteObject, hWndSBBkColor
	   	.EndIf
			Invoke FreeCusSBarParts	, hWin   	
		.EndIf
		Invoke DefWindowProc,hWin,uMsg,wParam,lParam		
		Ret
	CusStatusProc EndP