.386
.model flat,stdcall
option casemap:none

include CustTut.inc

.code

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

    push    hInst
    pop     hInstance
	invoke CreateClass
    mov     eax,TRUE
    ret

DllEntry Endp

;NOTE: RadASM 1.2.0.5 uses GetDef method.
;In RadASM.ini section [CustCtrl], x=CustCtrl.dll,y
;x is next free number.
;y is number of controls in the dll. In this case there is only one control.
;
;x=CustTut.dll,1
;Copy CustTut.dll to c:\radasm or to c:\windows\system
;
GetDef proc nInx:DWORD

	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_BMP
		mov		ccdef.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdef
	.else
		xor		eax,eax
	.endif
	ret

GetDef endp

;Used by RadASM 2.1.0.4
GetDefEx proc nInx:DWORD

	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_BMP
		mov		ccdefex.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdefex
	.else
		xor		eax,eax
	.endif
	ret

GetDefEx endp

CreateClass proc
	LOCAL	wc:WNDCLASSEX

	;Create a windowclass for the user control
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_PARENTDC or CS_DBLCLKS
	mov		wc.lpfnWndProc,offset ControlProc
	mov		eax,NULL
	mov		wc.cbClsExtra,eax
	mov		wc.cbWndExtra,eax
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,eax
	mov		wc.lpszMenuName,eax
	mov		wc.lpszClassName,offset szClassName
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret

CreateClass endp

;--------------------------------------------------------------------------------

Rotate proc uses esi edi,hBmpDest:DWORD,hBmpSrc:DWORD,x:DWORD,y:DWORD,nRotate:DWORD
	LOCAL	bmd:BITMAP
	LOCAL	nbitsd:DWORD
	LOCAL	hmemd:DWORD
	LOCAL	bms:BITMAP
	LOCAL	nbitss:DWORD
	LOCAL	hmems:DWORD

	;Get info on destination bitmap
	invoke GetObject,hBmpDest,sizeof BITMAP,addr bmd
	mov		eax,bmd.bmWidthBytes
	mov		edx,bmd.bmHeight
	mul		edx
	mov		nbitsd,eax
	;Allocate memory for destination bitmap bits
	invoke GlobalAlloc,GMEM_FIXED,nbitsd
	mov		hmemd,eax
	;Get the destination bitmap bits
	invoke GetBitmapBits,hBmpDest,nbitsd,hmemd
	;Get info on source bitmap
	invoke GetObject,hBmpSrc,sizeof BITMAP,addr bms
	mov		eax,bms.bmWidthBytes
	mov		edx,bms.bmHeight
	mul		edx
	mov		nbitss,eax
	;Allocate memory for source bitmap bits
	invoke GlobalAlloc,GMEM_FIXED,nbitss
	mov		hmems,eax
	;Get the source bitmap bits
	invoke GetBitmapBits,hBmpSrc,nbitss,hmems
	;Copy the pixels one by one
	xor		edx,edx
	.while edx<bms.bmHeight
		xor		ecx,ecx
		.while ecx<bms.bmWidth
			call	CopyPix
			inc		ecx
		.endw
		inc		edx
	.endw
	;Copy back the destination bitmap bits
	invoke SetBitmapBits,hBmpDest,nbitsd,hmemd
	;Free allocated memory
	invoke GlobalFree,hmems
	invoke GlobalFree,hmemd
	ret

CopyPix:
	push	ecx
	push	edx
	mov		esi,hmems
	push	edx
	mov		eax,bms.bmWidthBytes
	mul		edx
	add		esi,eax
	movzx	eax,bms.bmBitsPixel
	shr		eax,3
	mul		ecx
	add		esi,eax
	pop		edx
	mov		eax,nRotate
	.if eax==1
		;Rotate 90 degrees
		sub		edx,bms.bmHeight
		neg		edx
		xchg	ecx,edx
	.elseif eax==2
		;Rotate 180 degrees
		sub		edx,bms.bmHeight
		neg		edx
		sub		ecx,bms.bmWidth
		neg		ecx
	.elseif eax==3
		;Rotate 270 degrees
		sub		ecx,bms.bmWidth
		neg		ecx
		xchg	ecx,edx
	.endif
	;Add the destination offsets
	add		ecx,x
	add		edx,y
	.if  ecx<bmd.bmWidth && edx<bmd.bmHeight
		;Calculate destination adress
		mov		edi,hmemd
		mov		eax,bmd.bmWidthBytes
		mul		edx
		add		edi,eax
		movzx	eax,bmd.bmBitsPixel
		shr		eax,3
		xchg	eax,ecx
		mul		ecx
		add		edi,eax
		;And copy the byte(s)
		rep movsb
	.endif
	pop		edx
	pop		ecx
	retn

Rotate endp

ControlProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT
	LOCAL	rect1:RECT
	LOCAL	rect2:RECT
	LOCAL	dDC:HDC
	LOCAL	sDC:HDC
	LOCAL	hBmp1:DWORD
	LOCAL	hBmp2:DWORD
	LOCAL	buffer[256]:BYTE

	mov		eax,uMsg
	.if eax==WM_PAINT
		invoke GetClientRect,hWin,addr rect1
		.if rect1.right && rect1.bottom
			invoke BeginPaint,hWin,addr ps
			;Create a memory DC for the destination
			invoke CreateCompatibleDC,ps.hdc
			mov		dDC,eax
			;Create the destination bitmap
			invoke CreateCompatibleBitmap,ps.hdc,rect1.right,rect1.bottom
			mov		hBmp1,eax
			;and select it into the DC
			invoke SelectObject,dDC,hBmp1
			push	eax
			;Set destination background color
			invoke GetWindowLong,hWin,GWL_STYLE
			and		eax,12
			.if eax==0
				;Red
				mov		eax,0FFh
			.elseif eax==4
				;Green
				mov		eax,0FF00h
			.elseif eax==8
				;Blue
				mov		eax,0FF0000h
			.else
				;White
				mov		eax,0FFFFFFh
			.endif
			;Save back color
			push	eax
			;Create back brush
			invoke CreateSolidBrush,eax
			push	eax
			invoke FillRect,dDC,addr rect1,eax
			pop		eax
			;Delete back brush
			invoke DeleteObject,eax
			;Get the caption text lenght
			invoke GetWindowTextLength,hWin
			.if eax
				;Create a memory DC for the source
				invoke CreateCompatibleDC,ps.hdc
				mov		sDC,eax
				;Get back color
				pop		eax
				invoke SetBkColor,sDC,eax
				;Get size of text to draw
				mov		rect2.left,0
				mov		rect2.top,0
				mov		rect2.right,0
				mov		rect2.bottom,0
				invoke GetWindowText,hWin,addr buffer,sizeof buffer
				invoke SelectObject,sDC,hFont
				push	eax
				;Get text size
				invoke DrawText,sDC,addr buffer,-1,addr rect2,DT_CALCRECT or DT_SINGLELINE or DT_LEFT or DT_TOP
				;Create a bitmap for the text
				invoke CreateCompatibleBitmap,ps.hdc,rect2.right,rect2.bottom
				mov		hBmp2,eax
				;and select it into source DC
				invoke SelectObject,sDC,hBmp2
				push	eax
				;Draw the text
				invoke DrawText,sDC,addr buffer,-1,addr rect2,DT_SINGLELINE or DT_LEFT or DT_TOP
				;Rotate the bitmap
				invoke GetWindowLong,hWin,GWL_STYLE
				xor		ecx,ecx
				xor		edx,edx
				test	eax,STYLE_CENTER
				.if !ZERO?
					test	eax,01h
					.if ZERO?
						mov		edx,rect1.right
						sub		edx,rect2.right
						.if CARRY?
							neg		edx
							shr		edx,1
							neg		edx
						.else
							shr		edx,1
						.endif
						mov		ecx,rect1.bottom
						sub		ecx,rect2.bottom
						.if CARRY?
							neg		ecx
							shr		ecx,1
							neg		ecx
						.else
							shr		ecx,1
						.endif
					.else
						mov		edx,rect1.right
						sub		edx,rect2.bottom
						.if CARRY?
							neg		edx
							shr		edx,1
							neg		edx
						.else
							shr		edx,1
						.endif
						mov		ecx,rect1.bottom
						sub		ecx,rect2.right
						.if CARRY?
							neg		ecx
							shr		ecx,1
							neg		ecx
						.else
							shr		ecx,1
						.endif
					.endif
				.endif
				and		eax,3
				invoke Rotate,hBmp1,hBmp2,edx,ecx,eax
				;Select old bitmap
				pop		eax
				invoke SelectObject,sDC,eax
				;Delete created source bitmap
				invoke DeleteObject,eax
				;Select old font
				pop		eax
				invoke SelectObject,sDC,eax
				;Delete source DC
				invoke DeleteDC,sDC
			.endif
			;Blit the destination bitmap onto window bitmap
			invoke BitBlt,ps.hdc,rect1.left,rect1.top,rect1.right,rect1.bottom,dDC,0,0,SRCCOPY
			;Select old destination bitmap
			pop		eax
			invoke SelectObject,dDC,eax
			;and delete created destination bitmap
			invoke DeleteObject,eax
			;Delete destination DC
			invoke DeleteDC,dDC
			invoke EndPaint,hWin,addr ps
		.endif
		jmp		Ex
	.elseif eax==WM_SETFONT
		mov		eax,wParam
		mov		hFont,eax
		invoke InvalidateRect,hWin,NULL,TRUE
	.elseif eax==WM_SETTEXT
		invoke InvalidateRect,hWin,NULL,TRUE
	.endif
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
  Ex:
	ret

ControlProc endp

End DllEntry
