include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib

;VKim Debug
include masm32.inc
include \RadASM\masm\inc\debug.inc
includelib masm32.lib
includelib \RadASM\masm\lib\debug.lib

CreateClass			PROTO

;property1 starting with bit 31
;
;(Name)			*
;(ID)			*
;Left			*
;Top			*
;Width			*
;Height			*
;Caption		*
;Border			*
;SysMenu
;MaxButton
;MinButton
;Enabled		*
;Visible		*
;Clipping		*
;ScrollBar		*
;Default
;Auto
;Alignment
;Mnemonic
;WordWrap
;MultiLine
;Type
;Locked
;Child			*
;SizeBorder
;TabStop		*
;Font
;Menu
;Class
;Notify
;AutoScroll
;WantCr
;
;property2 starting with bit 31
;
;Sort
;Flat
;(StartID)
;TabIndex		*
;Format
;SizeGrip
;Group			*
;Icon
;UseTabs
;StartupPos
;Orientation
;SetBuddy
;MultiSelect
;HideSel
;TopMost
;xExStyle		*
;xStyle			*
;IntegralHgt
;Image
;Buttons
;PopUp
;OwnerDraw
;Transp
;Timer
;AutoPlay
;WeekNum
;AviClip
;AutoSize
;ToolTip
;Wrap
;Divider
;
;Note:
;Only some of the properties are general and can be used by the custom control.
;These properties are marked with *
;
;
;Used by RadASM 1.2.0.5. See RadASMini.rtf for more info
CCDEF struct
	ID			dd ?		;Controls uniqe ID
	lptooltip	dd ?		;Pointer to tooltip text
	hbmp		dd ?		;Handle of bitmap
	lpcaption	dd ?		;Pointer to default caption text
	lpname		dd ?		;Pointer to default id-name text
	lpclass		dd ?		;Pointer to class text
	style		dd ?		;Default style
	exstyle		dd ?		;Default ex-style
	property1	dd ?		;Property listbox 1 (bitflags on what properties are enabled)
	property2	dd ?		;Property listbox 2 (bitflags on what properties are enabled)
	disable		dd ?		;Disable controls child windows. 0=No, 1=Use method 1, 2=Use method 2
CCDEF ends

;Used by RadASM 2.1.0.4
CCDEFEX struct
	ID			dd ?		;Controls uniqe ID
	lptooltip	dd ?		;Pointer to tooltip text
	hbmp		dd ?		;Handle of bitmap
	lpcaption	dd ?		;Pointer to default caption text
	lpname		dd ?		;Pointer to default id-name text
	lpclass		dd ?		;Pointer to class text
	style		dd ?		;Default style
	exstyle		dd ?		;Default ex-style
	flist1		dd ?		;Property listbox 1
	flist2		dd ?		;Property listbox 2
	flist3		dd ?		;Property listbox 3
	flist4		dd ?		;Property listbox 4
	lpproperty	dd ?		;Pointer to properties text
	lpmethod	dd ?		;Pointer to property methods descriptor
CCDEFEX ends

PROP_STYLETRUEFALSE		equ 1
PROP_EXSTYLETRUEFALSE	equ 2
PROP_STYLEMULTI			equ 3

STYLE					equ WS_CHILD or WS_VISIBLE
EXSTYLE					equ 200h
IDB_BMP					equ 100

STYLE_0_DEG				equ 0000h
STYLE_90_DEG			equ 0001h
STYLE_180_DEG			equ 0002h
STYLE_270_DEG			equ 0003h
STYLE_RED				equ 0000h
STYLE_GREEN				equ 0004h
STYLE_BLUE				equ 0008h
STYLE_WHITE				equ 000Ch
STYLE_LEFTTOP			equ 0000h
STYLE_CENTER			equ 0010h

EXSTYLE_NONE			equ 0

.const

szToolTip				db 'Custom Control Tutorial',0
szCap					db 'IDC_TUT',0
szName					db 'IDC_TUT',0
szClassName				db 'CUSTOM_TUTORIAL',0

PropertyOrientation		db '0 deg.,90 deg.,180 deg.,270 deg.',0
						dd -1 xor 0003h,STYLE_0_DEG
						dd -1,EXSTYLE_NONE
						dd -1 xor 0003h,STYLE_90_DEG
						dd -1,EXSTYLE_NONE
						dd -1 xor 0003h,STYLE_180_DEG
						dd -1,EXSTYLE_NONE
						dd -1 xor 0003h,STYLE_270_DEG
						dd -1,EXSTYLE_NONE
PropertyBackColor		db 'Red,Green,Blue,White',0
						dd -1 xor 000Ch,STYLE_RED
						dd -1,EXSTYLE_NONE
						dd -1 xor 000Ch,STYLE_GREEN
						dd -1,EXSTYLE_NONE
						dd -1 xor 000Ch,STYLE_BLUE
						dd -1,EXSTYLE_NONE
						dd -1 xor 000Ch,STYLE_WHITE
						dd -1,EXSTYLE_NONE
PropertyCenter			dd -1 xor 0010h,STYLE_LEFTTOP
						dd -1 xor 0010h,STYLE_CENTER

Methods					dd PROP_STYLEMULTI,offset PropertyOrientation
						dd PROP_STYLEMULTI,offset PropertyBackColor
						dd PROP_STYLETRUEFALSE,offset PropertyCenter

.data

szProperty				db 'Orientation,BackColor,Center',0

ccdef					CCDEF <12345,offset szToolTip,0,offset szCap,offset szName,offset szClassName,STYLE,EXSTYLE,11111111000110000000000000000000b,00010000000000011000000000000000b,0>
ccdefex					CCDEFEX <12345,offset szToolTip,0,offset szCap,offset szName,offset szClassName,STYLE,EXSTYLE,11111111000110000000000000000000b,00010000000000011000000000000000b,00000000000000000000000000000000b,00000000000000000000000000000000b,offset szProperty,offset Methods>

.data?

hInstance				dd ?
hFont					dd ?
