.data?

hInstance			dd ?
NewProgPaint		PAINTSTRUCT<?>
NewProgWindowRect	RECT<?>

.Data

;***Progress Bar Control Data***
ProgClassName		db "TxPROGRESS",0
ClrRandSeed			dd 83C17F91h
StrDisplay			db "DISPLAY",0

RandomColorArray	dd 0FFh,0FF00h,0FF0000h,0F0FFFCh,998877h,212429h,0D17E3h,1F1AD4h,8CFFh,0D7FFh,148066h,70FF6Eh,0AB593Dh,0E16941h,0D355Bh,0B48246h

;***Extra Window Data Offset Constants***
PWL_BARCOLOR1		EQU  0
PWL_BARCOLOR2		EQU  4
PWL_RANGEMAX		EQU  8 
PWL_CURPOS			EQU 12
PWL_CURSTEP			EQU 16
PWL_GRADDC			EQU 20
PWL_GRADBMP			EQU 24
PWL_EXTRASIZE		EQU 28

;***Custom Messages***
UPM_MESSAGEBASE		EQU 600h
UPM_SETBARCOLOR1	EQU UPM_MESSAGEBASE + 00h
UPM_SETBARCOLOR2	EQU UPM_MESSAGEBASE + 01h
UPM_SETBARCOLORS	EQU UPM_MESSAGEBASE + 02h  
UPM_SETRANGE		EQU UPM_MESSAGEBASE + 03h
UPM_SETPOS			EQU UPM_MESSAGEBASE + 04h
UPM_SETSTEP			EQU UPM_MESSAGEBASE + 05h
UPM_STEPIT			EQU UPM_MESSAGEBASE + 06h
UPM_GETBARCOLOR1	EQU UPM_MESSAGEBASE + 07h
UPM_GETBARCOLOR2	EQU UPM_MESSAGEBASE + 08h
UPM_GETRANGE		EQU UPM_MESSAGEBASE + 09h
UPM_GETPOS			EQU UPM_MESSAGEBASE + 0Ah
UPM_GETSTEP			EQU UPM_MESSAGEBASE + 0Bh
UPM_RANDOMCOLOR		EQU UPM_MESSAGEBASE + 0Ch
UPM_RAINIT			equ WM_USER+9999

;-------------------------------------------------------------------------

STYLE				equ WS_CHILD or WS_VISIBLE
EXSTYLE				equ WS_EX_STATICEDGE

;Used by RadASM 1.2.0.5
CCDEF struct
	ID			dd ?					;Controls uniqe ID
	lptooltip	dd ?					;Pointer to tooltip text
	hbmp		dd ?					;Handle of bitmap
	lpcaption	dd ?					;Pointer to default caption text
	lpname		dd ?					;Pointer to default id-name text
	lpclass		dd ?					;Pointer to class text
	style		dd ?					;Default style
	exstyle		dd ?					;Default ex-style
	flist1		dd ?					;Property listbox 1
	flist2		dd ?					;Property listbox 2
	disable		dd ?					;Disable controls child windows. 0=No, 1=Use method 1, 2=Use method 2
CCDEF ends

IDB_GRADPROGRESS	equ 100

szToolTip			db 'GradProgress',0
szCap				db 0
szName				db 'IDC_GPB',0
;Create an initiated struct
ccdef				CCDEF <259,offset szToolTip,0,offset szCap,offset szName,offset ProgClassName,STYLE,EXSTYLE,11111101000110000000000000000000b,00010000000000011000000000000000b,0>

;-------------------------------------------------------------------------

;MACROs for the Switch/Case

_DefProgProc MACRO
	invoke	DefWindowProcA,HWnd,WMsg,WParam,LParam
ENDM


NewProgInitDCBMP MACRO
	;create dc for gradient
	invoke	GetClientRect,HWnd,offset NewProgWindowRect
	invoke	CreateCompatibleDC,0
	mov		ebx,eax
	invoke	SetWindowLongA,HWnd,PWL_GRADDC,eax
	;get screen dc
	invoke	CreateDCA,offset StrDisplay,0,0,0
	mov		edi,eax
	;create bitmap
	mov		eax,NewProgWindowRect.right
	sub		eax,NewProgWindowRect.left
	mov		edx,NewProgWindowRect.bottom
	sub		edx,NewProgWindowRect.top
	invoke	CreateCompatibleBitmap,edi,eax,edx
	mov		esi,eax
	invoke	SetWindowLongA,HWnd,PWL_GRADBMP,eax
	invoke	DeleteDC,edi
	;select bitmap into dc
	invoke	SelectObject,ebx,esi
	;create gradient in memory dc
	mov		edi,NewProgWindowRect.right
	sub		edi,NewProgWindowRect.left
	invoke	GetWindowLongA,HWnd,PWL_BARCOLOR1
	mov		esi,eax
	invoke	GetWindowLongA,HWnd,PWL_BARCOLOR2
	invoke	GradFill,ebx,offset NewProgWindowRect,esi,eax,edi
	_DefProgProc
ENDM


NewProgUpdateGradDC MACRO
	invoke	GetClientRect,HWnd,offset NewProgWindowRect
	mov		ebx,NewProgWindowRect.right
	sub		ebx,NewProgWindowRect.left
	invoke	GetWindowLongA,HWnd,PWL_BARCOLOR1
	mov		esi,eax
	invoke	GetWindowLongA,HWnd,PWL_BARCOLOR2
	mov		edi,eax
	invoke	GetWindowLongA,HWnd,PWL_GRADDC
	invoke	GradFill,eax,offset NewProgWindowRect,esi,edi,ebx
ENDM


_WM_PAINT MACRO
	invoke	BeginPaint,HWnd,offset NewProgPaint
	mov		ebx,eax
	;fill background
	invoke	GetClientRect,HWnd,offset NewProgWindowRect
	cmp		NewProgPaint.fErase,0
	je		@F ;@NewProgNoErase
	invoke	GetSysColorBrush,COLOR_BTNFACE
	invoke	FillRect,ebx,offset NewProgWindowRect,eax
;@NewProgNoErase:
@@:
	;draw progress bar
	invoke	GetWindowLongA,HWnd,PWL_CURPOS
	test	eax,eax
	jz		@F ;@NewProgNoProg
	mov		esi,eax
	invoke	GetWindowLongA,HWnd,PWL_RANGEMAX
	mov		ecx,eax
	;calc width of bar
	finit
	mov		eax,NewProgWindowRect.right
	sub		eax,NewProgWindowRect.left
	mov		edi,eax
	mov		Tmp,eax
	fild	Tmp
	mov		Tmp,ecx
	fidiv	Tmp
	mov		Tmp,esi
	fimul	Tmp
	fistp	Tmp
	invoke	GetWindowLongA,HWnd,PWL_GRADDC
	mov		edx,NewProgWindowRect.bottom
	sub		edx,NewProgWindowRect.top
	invoke	BitBlt,ebx,0,0,Tmp,edx,eax,0,0,SRCCOPY
;@NewProgNoProg:
@@:	invoke	EndPaint,HWnd,offset NewProgPaint
ENDM


_WM_CREATE MACRO
	;init randseed
	invoke	GetTickCount
	xor		ClrRandSeed,eax
	add		ClrRandSeed,eax
	rol		eax,13
	xor		ClrRandSeed,eax
	;set default color (black to blue)
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR1,00F0F0Fh
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR2,0F00000h
	;set default ranges/step
	invoke	SetWindowLongA,HWnd,PWL_RANGEMAX,100
	invoke	SetWindowLongA,HWnd,PWL_CURSTEP,1
	NewProgInitDCBMP
ENDM


_WM_DESTROY MACRO
	invoke	GetWindowLongA,HWnd,PWL_GRADDC
	invoke	DeleteDC,eax
	invoke	GetWindowLongA,HWnd,PWL_GRADBMP
	invoke	DeleteObject,eax
ENDM


_WM_SIZE MACRO
	invoke	GetWindowLongA,HWnd,PWL_GRADDC
	invoke	DeleteDC,eax
	invoke	GetWindowLongA,HWnd,PWL_GRADBMP
	invoke	DeleteObject,eax
	NewProgInitDCBMP
ENDM


_UPM_SETBARCOLORS MACRO
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR1,WParam
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR2,LParam
	NewProgUpdateGradDC
ENDM


_UPM_SETBARCOLOR1 MACRO
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR1,WParam
	NewProgUpdateGradDC
ENDM


_UPM_SETBARCOLOR2 MACRO
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR2,WParam
	NewProgUpdateGradDC
ENDM


_UPM_SETRANGE MACRO
	invoke	SetWindowLongA,HWnd,PWL_RANGEMAX,WParam
ENDM


_UPM_SETPOS MACRO
	mov		ebx,WParam
	invoke	GetWindowLongA,HWnd,PWL_RANGEMAX
	cmp		ebx,eax
	ja		@F ;@UPM_SETPOSFail
	invoke	SetWindowLongA,HWnd,PWL_CURPOS,ebx
	invoke	RedrawWindow,HWnd,0,0,RDW_INTERNALPAINT
	invoke	SendMessageA,HWnd,WM_PAINT,0,0
	ret ;this is bad!
;@UPM_SETPOSFail:
@@:	xor		eax,eax
ENDM


_UPM_SETSTEP MACRO
	mov		ebx,WParam
	invoke	GetWindowLongA,HWnd,PWL_RANGEMAX
	cmp		ebx,eax
	ja		@F ;@UPM_SETSTEPFail
	invoke	SetWindowLongA,HWnd,PWL_CURSTEP,ebx
	ret ;this is bad!
;@UPM_SETSTEPFail:
@@:	xor		eax,eax
ENDM


_UPM_STEPIT MACRO
	invoke	GetWindowLongA,HWnd,PWL_CURPOS
	mov		ebx,eax
	invoke	GetWindowLongA,HWnd,PWL_CURSTEP
	add		ebx,eax
	invoke	GetWindowLongA,HWnd,PWL_RANGEMAX
	cmp		ebx,eax
	ja		@F ;@UPM_STEPITNoRedraw
	invoke	SetWindowLongA,HWnd,PWL_CURPOS,ebx
	invoke	RedrawWindow,HWnd,0,0,RDW_INTERNALPAINT OR RDW_INVALIDATE
	invoke	SendMessageA,HWnd,WM_PAINT,0,0
@@:	;@UPM_STEPITNoRedraw:
ENDM


_UPM_GETBARCOLOR1 MACRO
	invoke	GetWindowLongA,HWnd,PWL_BARCOLOR1
ENDM


_UPM_GETBARCOLOR2 MACRO
	invoke	GetWindowLongA,HWnd,PWL_BARCOLOR2
ENDM


_UPM_GETRANGE MACRO
	invoke	GetWindowLongA,HWnd,PWL_RANGEMAX
ENDM


_UPM_GETPOS MACRO
	invoke	GetWindowLongA,HWnd,PWL_CURPOS
ENDM


_UPM_GETSTEP MACRO
	invoke	GetWindowLongA,HWnd,PWL_CURSTEP
ENDM


_UPM_RANDOMCOLOR MACRO
	mov		ebx,ClrRandSeed
	invoke	GetTickCount
	add		eax,ebx
	rol		eax,8
	xor		ClrRandSeed,eax
	and		eax,0Fh
	and		ebx,0Fh
	cmp		eax,ebx
	jne		@F ;@RandomNE
	xor		eax,1100b
;@RandomNE:
@@:	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR1,RandomColorArray[eax*4]
	invoke	SetWindowLongA,HWnd,PWL_BARCOLOR2,RandomColorArray[ebx*4]
	NewProgUpdateGradDC
ENDM


_UPM_RAINIT MACRO
	;Set range
	invoke	SetWindowLongA,HWnd,PWL_RANGEMAX,10
	;Set pos
	invoke	SetWindowLongA,HWnd,PWL_CURPOS,7
	invoke	RedrawWindow,HWnd,0,0,RDW_INTERNALPAINT
	invoke	SendMessageA,HWnd,WM_PAINT,0,0
ENDM

NULL_MACRO MACRO
	ret
ENDM
