.386
.model flat,stdcall
option casemap:none

include HL.inc

.code; HyperLink library by Faiseur.

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    push    hInst
    pop     hInstance
	invoke CreateClass
    mov     eax,TRUE
    ret
DllEntry Endp

GetDefEx proc nInx:DWORD;Used by RadASM 2.1.0.4
	mov		eax,nInx
	.if !eax ; Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_BMP
		mov		ccdefex.hbmp,eax
		mov		eax,offset ccdefex ; Return pointer to inited struct
	.else
		xor		eax,eax
	.endif
	ret
GetDefEx endp

CreateClass proc	;Create a windowclass for the user control
	LOCAL	wc:WNDCLASSEX

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_PARENTDC or CS_DBLCLKS
	mov		wc.lpfnWndProc,offset ControlProc
	mov		eax,NULL
	mov		wc.cbClsExtra,eax
	mov		wc.cbWndExtra,4
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,eax
	mov		wc.lpszMenuName,eax
	mov		wc.lpszClassName,offset szClassName
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret
CreateClass endp

;--------------------------------------------------------------------------------

Rotate proc uses esi edi,hBmpDest:DWORD,hBmpSrc:DWORD,x:DWORD,y:DWORD,nRotate:DWORD
	LOCAL	nbitsd,hmemd,nbitss,hmems:DWORD,bmd:BITMAP,bms:BITMAP

	;Get info on destination bitmap
	invoke GetObject,hBmpDest,sizeof BITMAP,addr bmd
	mov		eax,bmd.bmWidthBytes
	mov		edx,bmd.bmHeight
	mul		edx
	mov		nbitsd,eax
	;Allocate memory for destination bitmap bits
	invoke GlobalAlloc,GMEM_FIXED,nbitsd
	mov		hmemd,eax
	;Get the destination bitmap bits
	invoke GetBitmapBits,hBmpDest,nbitsd,hmemd
	;Get info on source bitmap
	invoke GetObject,hBmpSrc,sizeof BITMAP,addr bms
	mov		eax,bms.bmWidthBytes
	mov		edx,bms.bmHeight
	mul		edx
	mov		nbitss,eax
	;Allocate memory for source bitmap bits
	invoke GlobalAlloc,GMEM_FIXED,nbitss
	mov		hmems,eax
	;Get the source bitmap bits
	invoke GetBitmapBits,hBmpSrc,nbitss,hmems
	;Copy the pixels one by one
	xor		edx,edx
	.while edx<bms.bmHeight
		xor		ecx,ecx
		.while ecx<bms.bmWidth
			call	CopyPix
			inc		ecx
		.endw
		inc		edx
	.endw
	;Copy back the destination bitmap bits
	invoke SetBitmapBits,hBmpDest,nbitsd,hmemd
	;Free allocated memory
	invoke GlobalFree,hmems
	invoke GlobalFree,hmemd
	ret

CopyPix:
	push	ecx
	push	edx
	mov		esi,hmems
	push	edx
	mov		eax,bms.bmWidthBytes
	mul		edx
	add		esi,eax
	movzx	eax,bms.bmBitsPixel
	shr		eax,3
	mul		ecx
	add		esi,eax
	pop		edx
	mov		eax,nRotate
	.if eax==1
		;Rotate 90 degrees
		sub		edx,bms.bmHeight
		neg		edx
		xchg	ecx,edx
	.elseif eax==2
		;Rotate 180 degrees
		sub		edx,bms.bmHeight
		neg		edx
		sub		ecx,bms.bmWidth
		neg		ecx
	.elseif eax==3
		;Rotate 270 degrees
		sub		ecx,bms.bmWidth
		neg		ecx
		xchg	ecx,edx
	.endif
	;Add the destination offsets
	add		ecx,x
	add		edx,y
	.if  ecx<bmd.bmWidth && edx<bmd.bmHeight
		;Calculate destination adress
		mov		edi,hmemd
		mov		eax,bmd.bmWidthBytes
		mul		edx
		add		edi,eax
		movzx	eax,bmd.bmBitsPixel
		shr		eax,3
		xchg	eax,ecx
		mul		ecx
		add		edi,eax
		;And copy the byte(s)
		rep movsb
	.endif
	pop		edx
	pop		ecx
	retn

Rotate endp

SetHoverDetect proc hWin:DWORD
	invoke SetWindowLong,hWin,GWL_WNDPROC,OFFSET DetectHover
	invoke SetWindowLong,hWin,GWL_USERDATA,eax
	ret
SetHoverDetect endp

EndHoverDetect proc hWin:DWORD
	invoke GetWindowLong,hWin,GWL_WNDPROC
	.IF eax == OFFSET DetectHover
		invoke GetWindowLong,hWin,GWL_USERDATA
		invoke SetWindowLong,hWin,GWL_WNDPROC,eax
		mov eax,0
	.ELSE
		mov eax,-1
	.ENDIF
	ret
EndHoverDetect endp 

DetectHover proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL tme :TRACKMOUSEEVENT
	LOCAL pt :POINT
	LOCAL Fenetre:RECT
	LOCAL hParent:DWORD
	
	.IF uMsg == WM_MOUSEMOVE
		mov ebx,FUNC(GetWindowLong,hWin,0)
		.IF [ebx].HLINK.fHover == FALSE
			mov eax,hWin
			mov tme.hwndTrack,eax
			mov tme.cbSize,SIZEOF TRACKMOUSEEVENT
			mov tme.dwFlags,TME_HOVER or TME_LEAVE
			m2m tme.dwHoverTime,[ebx].HLINK.hovertimer ; hover timer in milliseconds
			invoke TrackMouseEvent,ADDR tme
			mov [ebx].HLINK.fHover,TRUE
		.ENDIF
	
	.ELSEIF uMsg == WM_MOUSEHOVER ; souris dans de la fentre
		mov ebx,FUNC(GetWindowLong,hWin,0)
		mov [ebx].HLINK.fHover,FALSE
		mov eax,[ebx].HLINK.colortext
		.if eax != [ebx].HLINK.coloractive
			m2m [ebx].HLINK.colortext,[ebx].HLINK.coloractive
			invoke GetParent,hWin	
			invoke GetClientRect,hWin,addr Fenetre		
			invoke InvalidateRect,hWin,addr Fenetre,TRUE		
		.endif
	
	.ELSEIF uMsg == WM_MOUSELEAVE ; souris en dehors de la fentre
		mov ebx,FUNC(GetWindowLong,hWin,0)
		mov [ebx].HLINK.fHover,FALSE
		mov eax,[ebx].HLINK.colortext
		.if eax != [ebx].HLINK.colornoactive
			m2m [ebx].HLINK.colortext,[ebx].HLINK.colornoactive
			invoke GetParent,hWin
			invoke GetClientRect,hWin,addr Fenetre		
			invoke InvalidateRect,hWin,addr Fenetre,TRUE		
		.endif
	.ENDIF
	
	invoke GetWindowLong,hWin,GWL_USERDATA
	invoke CallWindowProc,eax,hWin,uMsg,wParam,lParam
	ret
DetectHover endp

ControlProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT,rect1:RECT,rect2:RECT,tmpFont:LOGFONT
	LOCAL	dDC:HDC,sDC:HDC
	LOCAL	hBmp1,hBmp2:DWORD,buffer[256]:BYTE

	Switch uMsg
	Case WM_CREATE
		invoke GetClientRect,hWin,addr rect1	
		invoke GetProcessHeap
		mov	ebx,FUNC(HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof HLINK)
		invoke SetWindowLong,hWin,0,ebx
		mov [ebx].HLINK.fHover, FALSE
		mov [ebx].HLINK.colorbk,00FF0000h
		mov [ebx].HLINK.colortext,00ACFFACh
		mov [ebx].HLINK.coloractive,00FFFFFFh
		mov [ebx].HLINK.colornoactive,00ACFFACh
		mov [ebx].HLINK.hovertimer,40
		mov [ebx].HLINK.hFinger,0
	
	Case WM_DESTROY
		mov		ebx,FUNC(GetWindowLong,hWin,0)
		invoke GetProcessHeap
		invoke HeapFree,eax,0,ebx	
	
	Case WM_PAINT
		invoke GetClientRect,hWin,addr rect1
		.if rect1.right && rect1.bottom
			mov		ebx,FUNC(GetWindowLong,hWin,0)
			invoke BeginPaint,hWin,addr ps
			;Create a memory DC for the destination
			invoke CreateCompatibleDC,ps.hdc
			mov		dDC,eax
			;Create the destination bitmap
			invoke CreateCompatibleBitmap,ps.hdc,rect1.right,rect1.bottom
			mov		hBmp1,eax
			;and select it into the DC
			invoke SelectObject,dDC,hBmp1
			push	eax

			mov eax,[ebx].HLINK.colorbk ;couleur de fond
			
			push	eax
			;Create back brush
			invoke CreateSolidBrush,eax
			push	eax
			invoke FillRect,dDC,addr rect1,eax
			pop		eax
			;Delete back brush
			invoke DeleteObject,eax
			;Get the caption text lenght
			
			invoke GetWindowTextLength,hWin
			.if eax
				;Create a memory DC for the source
				invoke CreateCompatibleDC,ps.hdc
				mov		sDC,eax
				;Get back color
				pop		eax
				invoke SetBkColor,sDC,eax

				invoke SetTextColor,sDC,[ebx].HLINK.colortext ;couleur du texte
				
				;Get size of text to draw
				mov		rect2.left,0
				mov		rect2.top,0
				mov		rect2.right,0
				mov		rect2.bottom,0
				invoke GetWindowText,hWin,addr buffer,sizeof buffer
						

				invoke SelectObject,sDC,hFont
				push	eax
				;Get text size
				invoke DrawText,sDC,addr buffer,-1,addr rect2,DT_CALCRECT or DT_SINGLELINE or DT_LEFT or DT_TOP
				;Create a bitmap for the text
				invoke CreateCompatibleBitmap,ps.hdc,rect2.right,rect2.bottom
				mov		hBmp2,eax
				;and select it into source DC
				invoke SelectObject,sDC,hBmp2
				push	eax
				;Draw the text
				invoke DrawText,sDC,addr buffer,-1,addr rect2,DT_SINGLELINE or DT_LEFT or DT_TOP
				;Rotate the bitmap
				invoke GetWindowLong,hWin,GWL_STYLE
				xor		ecx,ecx
				xor		edx,edx
				test	eax,STYLE_CENTER
				.if !ZERO?
					test	eax,01h
					.if ZERO?
						mov		edx,rect1.right
						sub		edx,rect2.right
						.if CARRY?
							neg		edx
							shr		edx,1
							neg		edx
						.else
							shr		edx,1
						.endif
						mov		ecx,rect1.bottom
						sub		ecx,rect2.bottom
						.if CARRY?
							neg		ecx
							shr		ecx,1
							neg		ecx
						.else
							shr		ecx,1
						.endif
					.else
						mov		edx,rect1.right
						sub		edx,rect2.bottom
						.if CARRY?
							neg		edx
							shr		edx,1
							neg		edx
						.else
							shr		edx,1
						.endif
						mov		ecx,rect1.bottom
						sub		ecx,rect2.right
						.if CARRY?
							neg		ecx
							shr		ecx,1
							neg		ecx
						.else
							shr		ecx,1
						.endif
					.endif
				.endif
				and		eax,3
				invoke Rotate,hBmp1,hBmp2,edx,ecx,eax
				;Select old bitmap
				pop		eax
				invoke SelectObject,sDC,eax
				;Delete created source bitmap
				invoke DeleteObject,eax
				;Select old font
				pop		eax
				invoke SelectObject,sDC,eax
				;Delete source DC
				invoke DeleteDC,sDC
			.endif
			;Blit the destination bitmap onto window bitmap
			invoke BitBlt,ps.hdc,rect1.left,rect1.top,rect1.right,rect1.bottom,dDC,0,0,SRCCOPY
			;Select old destination bitmap
			pop		eax
			invoke SelectObject,dDC,eax
			;and delete created destination bitmap
			invoke DeleteObject,eax
			;Delete destination DC
			invoke DeleteDC,dDC
			invoke EndPaint,hWin,addr ps
		.endif
		ret

		
    Case WM_LBUTTONDOWN
    	mov ebx,FUNC(GetWindowLong,hWin,0)
    	.if [ebx].HLINK.hFinger != 0
			invoke GetWindowText,hWin,addr buffer,sizeof buffer 
			invoke ShellExecute, NULL,addr szOpen,addr buffer, NULL, NULL, SW_SHOWNORMAL 
			return 0
		.endif
    Case WM_SETCURSOR
    	mov ebx,FUNC(GetWindowLong,hWin,0)
		.if [ebx].HLINK.hFinger != 0
			invoke SetCursor,[ebx].HLINK.hFinger
			return 0
		.endif        
		    	
	Case HL_CURSOR
		mov ebx,FUNC(GetWindowLong,hWin,0)
		m2m [ebx].HLINK.hFinger,wParam
		return 0
		
	Case HL_BKCOLOR
		mov ebx,FUNC(GetWindowLong,hWin,0)
		m2m [ebx].HLINK.colorbk,wParam
		return 0
		
	Case HL_COLORTEXT
		mov ebx,FUNC(GetWindowLong,hWin,0)
  		m2m [ebx].HLINK.colornoactive,wParam
		m2m [ebx].HLINK.colortext,wParam
  		m2m [ebx].HLINK.coloractive,lParam	
		return 0

	Case HL_ACTIVEMOUSE
		invoke SetHoverDetect,hWin 
		mov ebx,FUNC(GetWindowLong,hWin,0)
		mov [ebx].HLINK.hFinger,FUNC (LoadCursor,hInstance,200)
		.if wParam < 5
			mov wParam,5
		.endif
		m2m [ebx].HLINK.hovertimer,wParam
		return 0
	Case HL_UNACTIVEMOUSE	
		invoke EndHoverDetect,hWin
		mov ebx,FUNC(GetWindowLong,hWin,0)
		mov [ebx].HLINK.hFinger,0
		mov [ebx].HLINK.hovertimer,40
		return 0
		
	Case HL_FONT
		m2m hFont,wParam
		return 0	
				
	Case WM_SETFONT                  
		invoke GetObject, wParam, sizeof LOGFONT,addr tmpFont
		mov tmpFont.lfUnderline, TRUE ; add under line 
		mov hFont,FUNC(CreateFontIndirect, addr tmpFont) ; Create the new font	
		return 0
		
	Case WM_SETTEXT
		invoke InvalidateRect,hWin,NULL,TRUE
	Endsw
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

ControlProc endp

End DllEntry
