include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include masm32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib masm32.lib

.const

;Button messages:
MBM_SETIMAGE			equ WM_USER+100	;wParam=0, lParam=bitmap handle
MBM_SETDISABLEDIMAGE	equ WM_USER+101	;wParam=0, lParam=bitmap handle
MBM_SETMOUSEOVERIMAGE	equ WM_USER+102	;wParam=0, lParam=bitmap handle
MBM_SETMENU				equ WM_USER+110	;wParam=0, lParam=popup menu handle

MBM_RAINIT				equ WM_USER+9999;wParam=0, lParam=pointer to controls DIALOG struct

;Button styles:
MBS_TEXT				equ 1			;The button has text
MBS_IMAGE				equ 2			;The button has image
MBS_MENU				equ 4			;The button has menu
MBS_IMAGELEFT			equ 8			;Image left, text right

;Button states:
MBST_MOUSEOVER			equ 1			;The mouse is over the button
MBST_MNUBTNDOWN			equ 2			;The menu button is pushed
MBST_BTNDOWN			equ 4			;The main button is pushed

;Button sizes
ARROW_WIDTH				equ 7			;Width of menu button arrow
ARROW_HEIGHT			equ 5			;Height of menu button arrow
MB_WIDTH				equ 11			;Width of menu button
TXT_HEIGHT				equ 20			;Height of text if bottom aligned

MNUBTN struct
	fState		dd ?					;Button state flag
	hMnuBmp		dd ?					;Handle of menu arrow bitmap
	hMnuBmpDis	dd ?					;Handle of disabled menu arrow bitmap
	hBmp		dd ?					;Handle of normal button bitmap
	bmpwt		dd ?					;Width of bitmap
	bmpht		dd ?					;Height of bitmap
	hBmpDis		dd ?					;Handle of disabled button bitmap
	bmpdiswt	dd ?					;Width of bitmap
	bmpdisht	dd ?					;Height of bitmap
	hBmpMo		dd ?					;Handle of mouse over button bitmap
	bmpmowt		dd ?					;Width of bitmap
	bmpmoht		dd ?					;Height of bitmap
	hFont		dd ?					;Handle of font
	cap			db 256 dup(?)			;Button text
	hMnu		dd ?					;Handle of button menu
	rc			RECT <?>				;Main rect
	rcI			RECT <?>				;Image rect
	rcT			RECT <?>				;Text rect
	rcM			RECT <?>				;Menu button rect
MNUBTN ends

STYLE			equ WS_CHILD or WS_VISIBLE or MBS_TEXT or MBS_IMAGE or MBS_MENU

;Used by RadASM 1.2.0.5
CCDEF struct
	ID			dd ?					;Controls uniqe ID
	lptooltip	dd ?					;Pointer to tooltip text
	hbmp		dd ?					;Handle of bitmap
	lpcaption	dd ?					;Pointer to default caption text
	lpname		dd ?					;Pointer to default id-name text
	lpclass		dd ?					;Pointer to class text
	style		dd ?					;Default style
	exstyle		dd ?					;Default ex-style
	flist1		dd ?					;Property listbox 1
	flist2		dd ?					;Property listbox 2
	disable		dd ?					;Disable controls child windows. 0=No, 1=Use method 1, 2=Use method 2
CCDEF ends

IDB_MNUBUTTON			equ 100
IDB_ARROW				equ 101
IDB_ARROWDIS			equ 102

.data

szClassNameMnuBtn		db 'MENU_BUTTON',0
szToolTip				db 'Menu Button',0
szCap					db 'IDC_MBN',0
szName					db 'IDC_MBN',0
;Create an inited struct
ccdef					CCDEF <257,offset szToolTip,0,offset szCap,offset szName,offset szClassNameMnuBtn,STYLE,0,11111111000110000000000000000000b,00010000000000011000000000000000b,0>

.data?

hInstance				dd ?
