.386
.model flat, stdcall
option casemap :none   ; case sensitive

include MnuBtnLIB.inc

.code

;Create a windowclass for the user control
CreateClass proc hInst:HINSTANCE
	LOCAL	wc:WNDCLASSEX

	push	hInst
	pop		_hInstance
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset MnuBtnProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,4		;Holds memory handle
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,NULL
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset szClassNameMnuBtn
	mov		eax,NULL
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret

CreateClass endp

;This proc does all the painting and drawing
PaintBtn proc uses ebx esi edi,hWin:HWND
	LOCAL	ps:PAINTSTRUCT
	LOCAL	mDC:HDC
	LOCAL	fdt:DWORD

	;Get the memory pointer
	invoke GetWindowLong,hWin,0
	mov		ebx,eax
	;Get the style
	invoke GetWindowLong,hWin,GWL_STYLE
	mov		esi,eax
	;Get the button state
	mov		edi,[ebx].MNUBTN.fState
	invoke BeginPaint,hWin,addr ps
	;Create a memory DC
	invoke CreateCompatibleDC,ps.hdc
	mov		mDC,eax
	;Create a bitmap for the DC
	invoke CreateCompatibleBitmap,ps.hdc,[ebx].MNUBTN.rc.right,[ebx].MNUBTN.rc.bottom
	invoke SelectObject,mDC,eax
	push	eax
	;Select the font into the DC
	mov		eax,[ebx].MNUBTN.hFont
	invoke SelectObject,mDC,eax
	push	eax
	;Draw text transparent
	invoke SetBkMode,mDC,TRANSPARENT
	call	DrawBtn
	call	DrawTxt
	call	DrawImg
	invoke BitBlt,ps.hdc,0,0,[ebx].MNUBTN.rc.right,[ebx].MNUBTN.rc.bottom,mDC,0,0,SRCCOPY
	;Restore old font
	pop		eax
	invoke SelectObject,mDC,eax
	;Restore old bitmap
	pop		eax
	invoke SelectObject,mDC,eax
	;Delete created bitmap
	invoke DeleteObject,eax
	;Delete created memory DC
	invoke DeleteDC,mDC
	invoke EndPaint,hWin,addr ps
	ret

DrawBtn:
	test	esi,MBS_MENU
	.if !ZERO?
		;The button has a menu, draw the menu button
		;Save the main button rect
		push	[ebx].MNUBTN.rc.right
		;Adjust the main button rect
		mov		eax,[ebx].MNUBTN.rcM.left
		inc		eax
		mov		[ebx].MNUBTN.rc.right,eax
		;Initially set both buttons unpushed
		mov		eax,DFCS_BUTTONPUSH
		mov		edx,eax
		test	edi,MBST_MOUSEOVER
		.if !ZERO?
			test	edi,MBST_BTNDOWN
			.if !ZERO?
				;Draw both buttons pushed
				or		eax,DFCS_PUSHED
				mov		edx,eax
			.else
				test	edi,MBST_MNUBTNDOWN
				.if !ZERO?
					;Draw menu button pushed
					or		edx,DFCS_PUSHED
				.endif
 			.endif
		.endif
		push	edx
		;Draw menu button
		invoke DrawFrameControl,mDC,addr [ebx].MNUBTN.rc,DFC_BUTTON,eax
		pop		eax
		;Draw main button
		invoke DrawFrameControl,mDC,addr [ebx].MNUBTN.rcM,DFC_BUTTON,eax
		;Restore the main button rect
		pop		[ebx].MNUBTN.rc.right
		;Initialy use disabled bitmap
		mov		eax,[ebx].MNUBTN.hMnuBmpDis
		test	esi,WS_DISABLED
		.if ZERO?
			;Use enabled bitmap
			mov		eax,[ebx].MNUBTN.hMnuBmp
		.endif
		.if eax
			;Draw the menu button bitmap
			mov		ecx,[ebx].MNUBTN.rcM.right
			add		ecx,[ebx].MNUBTN.rcM.left
			sub		ecx,ARROW_WIDTH
			shr		ecx,1
			mov		edx,[ebx].MNUBTN.rcM.bottom
			add		edx,[ebx].MNUBTN.rcM.top
			sub		edx,ARROW_HEIGHT
			shr		edx,1
			test	edi,MBST_MOUSEOVER
			.if !ZERO?
				test	edi,MBST_BTNDOWN or MBST_MNUBTNDOWN
				.if !ZERO?
					;Adjust the position for pushed button
					inc		ecx
					inc		edx
				.endif
			.endif
			invoke DrawTransparentBitmap,mDC,eax,ecx,edx,TBM_FIRSTPIXEL
		.endif
	.else
		;The button does not have a menu
		mov		eax,DFCS_BUTTONPUSH
		test	edi,MBST_MOUSEOVER
		.if !ZERO?
			test	edi,MBST_BTNDOWN or MBST_MNUBTNDOWN
			.if !ZERO?
				;Draw button pushed
				or		eax,DFCS_PUSHED
			.endif
		.endif
		;Draw the button
		invoke DrawFrameControl,mDC,addr [ebx].MNUBTN.rc,DFC_BUTTON,eax
	.endif
	retn

DrawTxt:
	test	esi,MBS_TEXT
	.if !ZERO?
		mov		fdt,DT_CENTER or DT_VCENTER or DT_SINGLELINE
		test	esi,MBS_IMAGELEFT
		.if !ZERO?
			mov		fdt,DT_RIGHT or DT_VCENTER or DT_SINGLELINE
		.endif
		test	esi,WS_DISABLED
		.if ZERO?
			;Normal text
			mov		eax,edi
			and		eax,MBST_BTNDOWN or MBST_MOUSEOVER
			xor		eax,MBST_BTNDOWN or MBST_MOUSEOVER
			.if ZERO?
				;Button pushed, adjust rect
				inc		eax
			.else
				;Don't adjust rect
				xor		eax,eax
			.endif
			push	eax
			lea		edx,[ebx].MNUBTN.rcT
			call	AdjustRect
			invoke DrawText,mDC,addr [ebx].MNUBTN.cap,-1,addr [ebx].MNUBTN.rcT,fdt
			pop		eax
			neg		eax
			lea		edx,[ebx].MNUBTN.rcT
			call	AdjustRect
		.else
			;Draw disabled text
			invoke GetSysColor,COLOR_BTNHILIGHT
			invoke SetTextColor,mDC,eax
			lea		edx,[ebx].MNUBTN.rcT
			mov		eax,1
			call	AdjustRect
			invoke DrawText,mDC,addr [ebx].MNUBTN.cap,-1,addr [ebx].MNUBTN.rcT,fdt
			invoke GetSysColor,COLOR_BTNSHADOW
			invoke SetTextColor,mDC,eax
			lea		edx,[ebx].MNUBTN.rcT
			mov		eax,-1
			call	AdjustRect
			invoke DrawText,mDC,addr [ebx].MNUBTN.cap,-1,addr [ebx].MNUBTN.rcT,fdt
		.endif
	.endif
	retn

DrawImg:
	test	esi,MBS_IMAGE
	.if !ZERO?
		;The button has an image
		xor		eax,eax
		mov		ecx,[ebx].MNUBTN.rcI.right
		mov		edx,[ebx].MNUBTN.rcI.bottom
		test	esi,WS_DISABLED
		.if ZERO?
			;Not disabled
			test	edi,MBST_MOUSEOVER
			.if !ZERO?
				;Use the mouse over image
				mov		eax,[ebx].MNUBTN.hBmpMo
				.if eax
					sub		ecx,[ebx].MNUBTN.bmpmowt
					sub		edx,[ebx].MNUBTN.bmpmoht
				.endif
			.endif
		.else
			;Button is disabled
			mov		eax,[ebx].MNUBTN.hBmpDis
			.if eax
				sub		ecx,[ebx].MNUBTN.bmpdiswt
				sub		edx,[ebx].MNUBTN.bmpdisht
			.endif
		.endif
		.if !eax
			;The button is not disabled or mouse is not over the button or these bitmaps are not set, use the main bitmap
			mov		eax,[ebx].MNUBTN.hBmp
			sub		ecx,[ebx].MNUBTN.bmpwt
			sub		edx,[ebx].MNUBTN.bmpht
		.endif
		.if eax
			;Draw the bitmap
			shr		ecx,1
			shr		edx,1
			test	esi,MBS_IMAGELEFT
			.if !ZERO?
				;The button has image left style set
				mov		ecx,4
			.endif
			test	edi,MBST_MOUSEOVER
			.if !ZERO?
				test	edi,MBST_BTNDOWN
				.if !ZERO?
					;The button is pushed, adjust position
					inc		ecx
					inc		edx
				.endif
			.endif
			;Draw the bitmap
			invoke DrawTransparentBitmap,mDC,eax,ecx,edx,TBM_FIRSTPIXEL
		.endif
	.endif
	retn

AdjustRect:
	add		[edx].RECT.left,eax
	add		[edx].RECT.top,eax
	add		[edx].RECT.right,eax
	add		[edx].RECT.bottom,eax
	retn

PaintBtn endp

MnuBtnProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rect:RECT
	LOCAL	bmp:BITMAP

	mov		eax,uMsg
	.if eax==WM_PAINT
		invoke PaintBtn,hWin
		xor		eax,eax
		ret
	.elseif eax==WM_MOUSEMOVE
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		;Get mouse position
		mov		eax,lParam
		mov		edx,eax
		and		eax,0FFFFh
		shr		edx,16
		test	[ebx].MNUBTN.fState,MBST_MOUSEOVER
		.if ZERO?
			.if eax<=[ebx].MNUBTN.rc.right && edx<=[ebx].MNUBTN.rc.bottom
				;The mouse is over the button
				or		[ebx].MNUBTN.fState,MBST_MOUSEOVER
				invoke SetCapture,hWin
				invoke InvalidateRect,hWin,NULL,TRUE
			.endif
		.else
			.if eax>[ebx].MNUBTN.rc.right || edx>[ebx].MNUBTN.rc.bottom
				;The mouse is outside the button area, remove mouse over state
				and		[ebx].MNUBTN.fState,-1 xor MBST_MOUSEOVER
				;Is a button pushed?
				test	[ebx].MNUBTN.fState,MBST_MNUBTNDOWN or MBST_BTNDOWN
				.if ZERO?
					;No buttons are pushed
					invoke ReleaseCapture
				.endif
				invoke InvalidateRect,hWin,NULL,TRUE
			.endif
		.endif
		xor		eax,eax
		ret
	.elseif eax==WM_LBUTTONDOWN
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		;Get mouse position
		mov		eax,lParam
		mov		edx,eax
		and		eax,0FFFFh
		shr		edx,16
		.if eax>[ebx].MNUBTN.rcM.left && eax<[ebx].MNUBTN.rcM.right && edx>[ebx].MNUBTN.rcM.top && edx<[ebx].MNUBTN.rcM.bottom
			;Set menu button down state
			or		[ebx].MNUBTN.fState,MBST_MNUBTNDOWN
		.else
			;Set main button down state
			or		[ebx].MNUBTN.fState,MBST_BTNDOWN
		.endif
		invoke InvalidateRect,hWin,NULL,TRUE
		xor		eax,eax
		ret
	.elseif eax==WM_LBUTTONUP
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		invoke ReleaseCapture
		test	[ebx].MNUBTN.fState,MBST_MOUSEOVER
		.if !ZERO?
			;Mouse is over button
			invoke GetWindowRect,hWin,addr rect
			invoke GetWindowLong,hWin,GWL_ID
			push	eax
			invoke GetParent,hWin
			pop		edx
			test	[ebx].MNUBTN.fState,MBST_BTNDOWN
			.if !ZERO?
				;Send a WM_COMMAND to parent window
				invoke PostMessage,eax,WM_COMMAND,edx,hWin
			.else
				test	[ebx].MNUBTN.fState,MBST_MNUBTNDOWN
				.if !ZERO?
					;Show the menu, if any
					mov		edx,[ebx].MNUBTN.hMnu
					.if edx
						invoke TrackPopupMenu,edx,TPM_LEFTALIGN,rect.left,rect.bottom,0,eax,NULL
					.endif
				.endif
			.endif
		.endif
		;Remove all button states
		and		[ebx].MNUBTN.fState,-1 xor (MBST_MOUSEOVER or MBST_MNUBTNDOWN or MBST_BTNDOWN)
		invoke InvalidateRect,hWin,NULL,TRUE
		xor		eax,eax
		ret
	.elseif eax==MBM_SETIMAGE
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		mov		eax,[ebx].MNUBTN.hBmp
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,lParam
		mov		[ebx].MNUBTN.hBmp,eax
		.if eax
			invoke GetObject,[ebx].MNUBTN.hBmp,sizeof BITMAP,addr bmp
			mov		eax,bmp.bmWidth
			mov		[ebx].MNUBTN.bmpwt,eax
			mov		eax,bmp.bmHeight
			mov		[ebx].MNUBTN.bmpht,eax
		.endif
	.elseif eax==MBM_SETDISABLEDIMAGE
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		mov		eax,[ebx].MNUBTN.hBmpDis
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,lParam
		mov		[ebx].MNUBTN.hBmpDis,eax
		.if eax
			invoke GetObject,[ebx].MNUBTN.hBmpDis,sizeof BITMAP,addr bmp
			mov		eax,bmp.bmWidth
			mov		[ebx].MNUBTN.bmpdiswt,eax
			mov		eax,bmp.bmHeight
			mov		[ebx].MNUBTN.bmpdisht,eax
		.endif
	.elseif eax==MBM_SETMOUSEOVERIMAGE
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		mov		eax,[ebx].MNUBTN.hBmpMo
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,lParam
		mov		[ebx].MNUBTN.hBmpMo,eax
		.if eax
			invoke GetObject,[ebx].MNUBTN.hBmpMo,sizeof BITMAP,addr bmp
			mov		eax,bmp.bmWidth
			mov		[ebx].MNUBTN.bmpmowt,eax
			mov		eax,bmp.bmHeight
			mov		[ebx].MNUBTN.bmpmoht,eax
		.endif
	.elseif eax==MBM_SETMENU
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		mov		eax,[ebx].MNUBTN.hMnu
		.if eax
			invoke DestroyMenu,eax
		.endif
		mov		eax,lParam
		mov		[ebx].MNUBTN.hMnu,eax
	.elseif eax==WM_CREATE
		push	esi
		;Get style
		invoke GetWindowLong,hWin,GWL_STYLE
		mov		esi,eax
		;Allocate memory for the button
		invoke GetProcessHeap
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof MNUBTN
		mov		ebx,eax
		;Save the pointer
		invoke SetWindowLong,hWin,0,eax
		test	esi,MBS_TEXT
		.if !ZERO?
			;Get the text
			invoke GetWindowText,hWin,addr [ebx].MNUBTN.cap,sizeof MNUBTN.cap
		.endif
		test	esi,MBS_MENU
		.if !ZERO?
			;Load the menu button bitmaps
			invoke LoadBitmap,_hInstance,IDB_ARROW
			mov		[ebx].MNUBTN.hMnuBmp,eax
			invoke LoadBitmap,_hInstance,IDB_ARROWDIS
			mov		[ebx].MNUBTN.hMnuBmpDis,eax
		.endif
		pop		esi
	.elseif eax==WM_SIZE
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		invoke GetClientRect,hWin,addr [ebx].MNUBTN.rc
		invoke CopyRect,addr [ebx].MNUBTN.rcI,addr [ebx].MNUBTN.rc
		invoke CopyRect,addr [ebx].MNUBTN.rcT,addr [ebx].MNUBTN.rc
		invoke CopyRect,addr [ebx].MNUBTN.rcM,addr [ebx].MNUBTN.rc
		;Get style
		invoke GetWindowLong,hWin,GWL_STYLE
		mov		edx,eax
		test	edx,MBS_MENU
		.if !ZERO?
			;Set menu button rect
			mov		eax,[ebx].MNUBTN.rc.right
			sub		eax,MB_WIDTH
			jnc		@f
			xor		eax,eax
		  @@:
			mov		[ebx].MNUBTN.rcI.right,eax
			mov		[ebx].MNUBTN.rcT.right,eax
			mov		[ebx].MNUBTN.rcM.left,eax
		.endif
		test	edx,MBS_TEXT
		.if !ZERO?
			test	edx,MBS_IMAGE
			.if !ZERO?
				;The button has image
				test	edx,MBS_IMAGELEFT
				.if ZERO?
					;The text is at center-bottom
					mov		eax,[ebx].MNUBTN.rcT.bottom
					sub		eax,TXT_HEIGHT
					mov		[ebx].MNUBTN.rcT.top,eax
					mov		[ebx].MNUBTN.rcI.bottom,eax
				.else
					;The text is at right-middle
					sub		[ebx].MNUBTN.rcT.right,4
				.endif
			.endif
		.endif
	.elseif eax==WM_DESTROY
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		;Destroy bitmaps
		mov		eax,[ebx].MNUBTN.hMnuBmp
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,[ebx].MNUBTN.hMnuBmpDis
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,[ebx].MNUBTN.hBmp
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,[ebx].MNUBTN.hBmpDis
		.if eax
			invoke DeleteObject,eax
		.endif
		mov		eax,[ebx].MNUBTN.hBmpMo
		.if eax
			invoke DeleteObject,eax
		.endif
		;Destroy menu
		mov		eax,[ebx].MNUBTN.hMnu
		.if eax
			invoke DestroyMenu,eax
		.endif
		;Free memory
		invoke GetProcessHeap
		invoke HeapFree,eax,NULL,ebx
	.elseif eax==WM_SETTEXT
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		;Get text
		invoke lstrcpyn,addr [ebx].MNUBTN.cap,lParam,sizeof MNUBTN.cap
		invoke InvalidateRect,hWin,NULL,TRUE
	.elseif eax==WM_SETFONT
		;Get memory pointer
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		;Save the font handle
		mov		eax,wParam
		mov		[ebx].MNUBTN.hFont,eax
		invoke InvalidateRect,hWin,NULL,TRUE
	.elseif eax==WM_ENABLE
		invoke InvalidateRect,hWin,NULL,TRUE
	.endif
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

MnuBtnProc endp

End
