include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
include masm32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib masm32.lib

.const

;Button messages:
MBM_SETIMAGE			equ WM_USER+100	;wParam=0, lParam=bitmap handle
MBM_SETDISABLEDIMAGE	equ WM_USER+101	;wParam=0, lParam=bitmap handle
MBM_SETMOUSEOVERIMAGE	equ WM_USER+102	;wParam=0, lParam=bitmap handle
MBM_SETMENU				equ WM_USER+110	;wParam=0, lParam=popup menu handle

;Button styles:
MBS_TEXT				equ 1			;The button has text
MBS_IMAGE				equ 2			;The button has image
MBS_MENU				equ 4			;The button has menu
MBS_IMAGELEFT			equ 8			;Image left, text right

;Button states:
MBST_MOUSEOVER			equ 1			;The mouse is over the button
MBST_MNUBTNDOWN			equ 2			;The menu button is pushed
MBST_BTNDOWN			equ 4			;The main button is pushed

;Button sizes
ARROW_WIDTH				equ 7			;Width of menu button arrow
ARROW_HEIGHT			equ 5			;Height of menu button arrow
MB_WIDTH				equ 11			;Width of menu button
TXT_HEIGHT				equ 20			;Height of text if bottom aligned

MNUBTN struct
	fState		dd ?					;Button state flag
	hMnuBmp		dd ?					;Handle of menu arrow bitmap
	hMnuBmpDis	dd ?					;Handle of disabled menu arrow bitmap
	hBmp		dd ?					;Handle of normal button bitmap
	bmpwt		dd ?					;Width of bitmap
	bmpht		dd ?					;Height of bitmap
	hBmpDis		dd ?					;Handle of disabled button bitmap
	bmpdiswt	dd ?					;Width of bitmap
	bmpdisht	dd ?					;Height of bitmap
	hBmpMo		dd ?					;Handle of mouse over button bitmap
	bmpmowt		dd ?					;Width of bitmap
	bmpmoht		dd ?					;Height of bitmap
	hFont		dd ?					;Handle of font
	cap			db 256 dup(?)			;Button text
	hMnu		dd ?					;Handle of button menu
	rc			RECT <?>				;Main rect
	rcI			RECT <?>				;Image rect
	rcT			RECT <?>				;Text rect
	rcM			RECT <?>				;Menu button rect
MNUBTN ends

IDB_ARROW				equ 9998
IDB_ARROWDIS			equ 9999

.data

szClassNameMnuBtn		db 'MENU_BUTTON',0

.data?

_hInstance				dd ?
