.386
.model flat,stdcall
option casemap:none

include RaGraphLib.inc
include Proc\3DFrame.asm
include Proc\Function.asm
.code

; RaGraph library by Faiseur.
; Note for "profdracula": Copy this code and adds the possibility of changing the color of the frame, if you want :-)

RG	PROC
   LOCAL idThread:DWORD
    invoke CloseHandle,FUNC (CreateThread,0,0,addr CreateClass,0,0,addr idThread)
    ret
RG Endp

CreateClass proc
	LOCAL	wc:WNDCLASSEX

	;Create a windowclass for the user control
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_PARENTDC or CS_DBLCLKS
	mov		wc.lpfnWndProc,offset ControlProc
	mov		eax,NULL
	mov		wc.cbClsExtra,eax
	mov		wc.cbWndExtra,4
	push	hInstance
	pop		wc.hInstance
	mov		wc.hbrBackground,eax
	mov		wc.lpszMenuName,eax
	mov		wc.lpszClassName,offset szClassName
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret
CreateClass endp

;--------------------------------------------------------------------------------


ControlProc proc uses ebx edi,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	LOCAL hdc:HDC
	LOCAL number:DWORD
	
	Switch uMsg
	Case WM_CREATE
		invoke GetProcessHeap
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof MULTIDATA
		mov ebx,eax
		invoke SetWindowLong,hWin,0,ebx
		; 20 Bars
		invoke HeapCreate,0,16*1024,256*1024
		mov [ebx].MULTIDATA.hHeap,eax
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,20*sizeof BAR
		mov [ebx].MULTIDATA.lpBars,eax
		mov [ebx].MULTIDATA.Maxi,100
		mov [ebx].MULTIDATA.Background,00D20000h
		mov [ebx].MULTIDATA.Shadowgraph,00000000h
		mov [ebx].MULTIDATA.Shadow,0
		mov [ebx].MULTIDATA.Space,1
		mov [ebx].MULTIDATA.Total,4
		mov [ebx].MULTIDATA.State,FALSE
		invoke Pourcent,hWin,1,50
		invoke Pourcent,hWin,2,80
		invoke Pourcent,hWin,3,30
		invoke Pourcent,hWin,4,20
		
		invoke Couleurgraph,1,00FFFF80h
		invoke Couleurgraph,2,008080FFh
		invoke Couleurgraph,3,0080FFFFh
		invoke Couleurgraph,4,008000FFh
		
		; texte par dfaut
		mov edi,[ebx].MULTIDATA.lpBars
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
		m2m [edi].BAR.Dstring,offset Txt
		add edi,sizeof BAR
		inc number
		mov eax,number
		.endw
		; texte par dfaut
	
	
	Case WM_DESTROY
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		invoke HeapFree,[ebx].MULTIDATA.hHeap,0,[ebx].MULTIDATA.lpBars
		invoke HeapDestroy,[ebx].MULTIDATA.hHeap
		invoke GetProcessHeap
		invoke HeapFree,eax,0,ebx
	
	
	Case WM_PAINT
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		mov hdc,FUNC (BeginPaint,hWin,addr ps)
		
		invoke GetClientRect,hWin,addr rect
		cmp ps.fErase,0
		je @F
		.if [ebx].MULTIDATA.State == FALSE
		invoke GetSysColorBrush,COLOR_BTNFACE
		invoke FillRect,hdc,addr rect,eax
		.endif
		
		@@:
		invoke Prep,hWin,hdc
		mov number,1
		mov eax,number
		.WHILE eax <= [ebx].MULTIDATA.Total
		invoke Calc,hWin,hdc,number ; calcule les paramtres de la colonne
		invoke graph,hWin,hdc,number
		inc number
		mov eax,number
		.ENDW
		
		mov edi,[ebx].MULTIDATA.lpBars
		mov number,1
		mov eax,1
		.WHILE eax <= 20
		invoke Ligne,hWin,hdc,[edi].BAR.Dline
		add edi,sizeof BAR
		inc number
		mov eax,number
		.ENDW
		invoke EndPaint,hWin,addr ps
	
	
	Case RG_INIT ; wParam = space /lParam = total
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		m2m [ebx].MULTIDATA.Space,wParam
		m2m [ebx].MULTIDATA.Total, lParam
		
		invoke HeapFree,[ebx].MULTIDATA.hHeap,0,[ebx].MULTIDATA.lpBars
		
		; lParam bars
		mov eax,sizeof BAR
		mov edx,lParam
		.if edx<20
			; Not less than 20
			mov edx,20
		.endif
		
		mul edx
		invoke HeapAlloc,[ebx].MULTIDATA.hHeap,HEAP_ZERO_MEMORY,eax; bug when the news memory is larger than the memory by defect ( > 20*sizeof BAR)
		
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
			invoke Pourcent,hWin,number,0
			inc number
			mov eax,number
		.ENDW
		
		; si texte par dfaut
		mov edi,[ebx].MULTIDATA.lpBars
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
			m2m [edi].BAR.Dstring,0
			add edi,sizeof BAR
			inc number
			mov eax,number
		.endw
		; si texte par dfaut
		mov [ebx].MULTIDATA.State,FALSE
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_COUNT ; wParam = number / lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		
		.if wParam == 0
			mov number,1
			mov eax,1
			.WHILE eax <= [ebx].MULTIDATA.Total
				invoke Pourcent,hWin,number,lParam
				inc number
				mov eax,number
			.ENDW
			invoke InvalidateRect,hWin,0,FALSE
			return 0
		.endif
		invoke Pourcent,hWin,wParam,lParam
		mov [ebx].MULTIDATA.State,TRUE
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_COLORBACK ; lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		    m2m [ebx].MULTIDATA.Background,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_COLORGRAPH ; wParam = number / lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		.if wParam == 0
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
			invoke Couleurgraph,number,lParam
			inc number
			mov eax,number
		.ENDW
		invoke InvalidateRect,hWin,0,FALSE
		return 0
		.endif
		invoke Couleurgraph,wParam,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_TEXT ; wParam = number / lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		
		; invoke lstrcpyn,addr Buff,lParam,sizeof lParam
		
		.if wParam == 0
		mov edi,[ebx].MULTIDATA.lpBars
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
		m2m [edi].BAR.Dstring,lParam
		add edi,sizeof BAR
		inc number
		mov eax,number
		.ENDW
		invoke InvalidateRect,hWin,0,FALSE
		return 0
		.endif
		
		
		mov edi,wParam
		dec edi
		mov eax,sizeof BAR
		mul edi
		mov edi,eax
		add edi,[ebx].MULTIDATA.lpBars
		
		; mov edi,[ebx].MULTIDATA.lpBars
		; mov number,1
		; mov eax,1
		; .WHILE eax < wParam
		; add edi,sizeof BAR
		; inc number
		; mov eax,number
		; .endw
		
		m2m [edi].BAR.Dstring,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_COLORTEXT ; wParam = number / lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		
		.if wParam == 0
		mov edi,[ebx].MULTIDATA.lpBars
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
		m2m [edi].BAR.Dcolortext,lParam
		add edi,sizeof BAR
		inc number
		mov eax,number
		.ENDW
		invoke InvalidateRect,hWin,0,FALSE
		return 0
		.endif
		mov edi,wParam
		dec edi
		mov eax,sizeof BAR
		mul edi
		mov edi,eax
		add edi,[ebx].MULTIDATA.lpBars
		
		; mov edi,[ebx].MULTIDATA.lpBars
		; mov number,1
		; mov eax,1
		; .WHILE eax < wParam
		; add edi,sizeof BAR
		; inc number
		; mov eax,number
		; .endw
		m2m [edi].BAR.Dcolortext,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_FONT ; wParam = number / lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		.if wParam == 0
		mov edi,[ebx].MULTIDATA.lpBars
		mov number,1
		mov eax,1
		.WHILE eax <= [ebx].MULTIDATA.Total
		m2m [edi].BAR.Dfont,lParam
		add edi,sizeof BAR
		inc number
		mov eax,number
		.ENDW
		invoke InvalidateRect,hWin,0,FALSE
		return 0
		.endif
		mov edi,wParam
		dec edi
		mov eax,sizeof BAR
		mul edi
		mov edi,eax
		add edi,[ebx].MULTIDATA.lpBars
		
		; mov edi,[ebx].MULTIDATA.lpBars
		; mov number,1
		; mov eax,1
		; .WHILE eax < wParam
		; add edi,sizeof BAR
		; inc number
		; mov eax,number
		; .endw
		m2m [edi].BAR.Dfont,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_LINE ; wParam = number / lParam = value
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		.if wParam == 0
			mov edi,[ebx].MULTIDATA.lpBars
			mov number,1
			mov eax,1
			.WHILE eax <= 20 ; maxi: 20 lignes
				m2m [edi].BAR.Dline,lParam
				add edi,sizeof BAR
				inc number
				mov eax,number
			.ENDW
			invoke InvalidateRect,hWin,0,FALSE
			return 0
		.endif
		mov edi,wParam
		dec edi
		mov eax,sizeof BAR
		mul edi
		mov edi,eax
		add edi,[ebx].MULTIDATA.lpBars
		
		; mov edi,[ebx].MULTIDATA.lpBars
		; mov number,1
		; mov eax,1
		; .WHILE eax < wParam
		; add edi,sizeof BAR
		; inc number
		; mov eax,number
		; .endw
		m2m [edi].BAR.Dline,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_CHANGEMAXI
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		m2m [ebx].MULTIDATA.Maxi,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Case RG_LINESTYLE
		invoke GetWindowLong,hWin,0
		mov ebx,eax
		m2m [ebx].MULTIDATA.LinesWidth,wParam
		m2m [ebx].MULTIDATA.LinesColor,lParam
		invoke InvalidateRect,hWin,0,FALSE
		
	Case RG_3DSTYLE
		invoke GetWindowLong,hWin,0
		mov ebx,eax	
		m2m [ebx].MULTIDATA.Shadow,wParam
		m2m [ebx].MULTIDATA.Shadowgraph,lParam
		invoke InvalidateRect,hWin,0,FALSE
	
	Endsw
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
	ret

ControlProc endp

end